//==========================================================================
// GoldenEye 007 Multiplayer Client/Server
//==========================================================================
// Copyright (c) 2014, stolen
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the <organization> nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL STOLEN BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//==========================================================================
// TODO:
// recode network packet system (too expensive as of 0.6)
// sync doors
// sync explosions
// sync weapon drop positions
// sync ammo pickup
// add support for 4 players
// make a GUI
// keep fixing GE-MP and test on mupen (perfect test case for slower PCs)
// repeat last step until you're bored
//==========================================================================
#include <stdio.h>
#include <windows.h>
#include <conio.h>
#include <tlhelp32.h>
#include <math.h>
#include <time.h>
#include <pthread.h>
#include <enet/enet.h>

// input for menu interface
#define K_0 GetAsyncKeyState(0x30) // key '0'
#define K_1 GetAsyncKeyState(0x31) // key '1'
#define K_6 GetAsyncKeyState(0x36) // key '6'
#define K_7 GetAsyncKeyState(0x37) // key '7'
#define K_8 GetAsyncKeyState(0x38) // key '8'
#define K_9 GetAsyncKeyState(0x39) // key '9'
#define K_PLUS (GetAsyncKeyState(0x6B) || GetAsyncKeyState(0xBB)) // key '+'
#define K_MINUS (GetAsyncKeyState(0x6D) || GetAsyncKeyState(0xBD)) // key '-'
// misc
#define TITLE "GoldenEye 007 Multiplayer Client/Server ("VERSION")\n"
#define VERSION "v0.6"
#define LINE "_______________________________________________________________"
#define SERVER 0 // server is player 1
#define CLIENT 1 // client is player 2
#define MIN_TICKRATE 5
#define MAX_TICKRATE 80
#define NOGUN 99 // magic number for null inventory array item
#define INVENTORYPOINTER(X) ReadMemoryInt(playerbase[X], GE.mp_inventory) - 0x80000000 // used for accessing the inventory array that is used on the current map
#define DEBUG_19641 0 // setting this to 1 means program will not search for 1964.exe, but instead search for 19641.exe (easy for rapid testing on a single PC)

void Input();
void Interface();
void LoadSettings();
void SaveSettings();
void InitNetwork();
void Server();
void Client();
void Hook();
void RecvPacket(const char *packet, const int channel);
void SendPacket();
void *Maintenance();
void InjMenu(const char *packet);
void InjMulti(const char *packet);
int MenuChanged();
void StartRound();
void GiveWeapon(const int weapon);
void DetectStatus();
int SafeToInject();
int AmmoType(const int weaponid);
void SortArray(int *a, const int n);
float Direction(const float localx, const float localy, const float peerx, const float peery);
int EmulatorDetected();
void InitAddressTables();
int ReadMemoryInt(const int addr, const int offset);
float ReadMemoryFloat(const int addr, const int offset);
void WriteMemoryInt(const int addr, const int value, const int offset);
void WriteMemoryFloat(const int addr, const float value, const int offset);
void PrintError(const char *exitmsg, const int exitflag);
void CleanUp();
void ClearScreen();

struct
{
	int controllersconnected, controller[2], camera, exit, pause[2], rng, time, musictrack, clock, showclock; // misc vars to store static addresses
	int m_scenario, m_level, m_gamelength, m_weaponset, m_character[2], m_selectablecharacters, m_health[2], m_controlstyle[2], m_aim[3], m_cheats[10]; // vars to store important menu vars
	int m_page, m_crosshairx, m_crosshairy, m_start[2], m_freeze[7], m_lock[2], m_players, m_characterscroll[2], m_title[6]; // vars to store misc menu addresses
	int mp_crouchheight, mp_deathflag, mp_invulnerable, mp_health, mp_shield, mp_hudhealth, mp_hudshield, mp_showhud, mp_camx, mp_camy, mp_crosshairx, mp_crosshairy, mp_xpos, mp_ypos, mp_zpos, mp_weaponammo, mp_weaponmodel, mp_weaponfunction, mp_inventory, mp_totalammo[8], mp_portalid, mp_startrespawn, mp_startmenupage, mp_start, mp_scorekill[2], mp_matchended, mp_scoredeath[2], mp_scoresuicide[2], mp_freeze, mp_rgba[4], mp_pushx, mp_pushy; // vars to store multiplayer addresses
} GE;

const char *tickrating[9] = {"DDoS", "Lossless", "LAN", "Excellent", "Good", "Average", "Below Average", "Poor", "Horrible"};
ENetHost *self = NULL;
ENetPeer *peer = NULL;
ENetAddress address;
ENetEvent event;
pthread_t manthread; // this is our thread identifier
HANDLE emuhandle; // this stores the emulator process id
int emuoffset; // var used for adding emulator offsets to memory address injections (see ReadMemory functions)
int closethread = 0; // set this to 1 to end the thread
int maploaded = 0; // var is used for detecting when a map has loaded, but player has not spawned in said map
int spawned = 0; // when player has started the zoom in, this var will be enabled
int playerbase[2] = {0, 0};
int peer_maploaded = 0; // used to store other player's map loaded status
int peer_lastinput = 0; // used for injecting the last recv input for other player (Maintenance() uses this)
int peer_deathflag = 0; // used to sync remote peer with local death animation (RNG makes animations random so GE-MP will wait until death animation has finished before respawning)
int peer_connected = 0; // used for server to determin when the client has connected
char latestmenupacket[1024] = "0@1@2@11@0@1@5@5@0@0@1@0@0@0@0@0@0@0@0@0@0@0@0@40"; // used to store the last sent/recv menu settings packet which GE-MP uses to check if the menu has changed
// vars using a s_ prefix are setting vars
char s_ipaddress[128] = "192.168.0.1";
int s_port = 46102;
int s_mode = 1; // stores what mode the program is running in (SERVER/CLIENT)
int s_blackscreen = 0; // var controls if peer is to have a blacked out screen by default
int s_spawnweapon = 0; // don't spawn with PP7
int s_doctorno = 0; // no shield settings
int s_countdown = 0; // shows the countdown clock for match (only if game length setting is time based)
int s_tickrate = 40; // 10 is the data speed limit before GE-MP starts getting lossy input which results in somewhat desynced gameplay, however, 50 is good enough for internet play (80 is max before netsync starts to get broken)

int main()
{
	SetConsoleTitle("GE-MP - "VERSION); // sets the console title
	InitAddressTables(); // load up GE addresses for GE struct
	atexit(CleanUp); // assign custom clean up function when program exits
	LoadSettings(); // load connection settings
	Interface(); // load interface
	while(SafeToInject())
	{
		WriteMemoryInt(GE.camera, 10, 0); // force player to stay in menu
		Input();
		Sleep(40);
	}
	exit(EXIT_FAILURE);
}
//==========================================================================
// Purpose: checks user input and changes program settings based upon user input
// Changes Globals: s_mode, s_blackscreen, s_spawnweapon, s_doctorno, s_countdown, s_tickrate
//==========================================================================
void Input()
{
	int updateinterface = 0, quickupdate = 0;
	if(K_1) // server/client mode toggle
	{
		s_mode = !s_mode;
		s_blackscreen = 0;
		s_spawnweapon = 0;
		s_doctorno = 0;
		s_countdown = 0;
		s_tickrate = 40;
		updateinterface = 1;
	}
	if(K_6 && !updateinterface && s_mode == SERVER) // blackscreen toggle
	{
		s_blackscreen = !s_blackscreen;
		updateinterface = 1;
	}
	if(K_7 && !updateinterface && s_mode == SERVER) // spawn weapon mode
	{
		s_spawnweapon = !s_spawnweapon;
		updateinterface = 1;
	}
	if(K_8 && !updateinterface && s_mode == SERVER) // enable/disable shields
	{
		s_doctorno = !s_doctorno;
		updateinterface = 1;
	}
	if(K_9 && !updateinterface && s_mode == SERVER) // show countdown clock
	{
		s_countdown = !s_countdown;
		updateinterface = 1;
	}
	if(K_0 && !updateinterface) // start
	{
		WriteMemoryInt(GE.camera, 10, 0); // force player to return to menu
		InitNetwork();
	}
	if(K_PLUS && !updateinterface && s_mode == SERVER && s_tickrate < MAX_TICKRATE) // numpad plus (+)
	{
		s_tickrate++;
		updateinterface = 1;
		quickupdate = 1;
	}
	if(K_MINUS && !updateinterface && s_mode == SERVER && s_tickrate > MIN_TICKRATE) // numpad minus (-)
	{
		s_tickrate--;
		updateinterface = 1;
		quickupdate = 1;
	}
	if(updateinterface)
	{
		Interface();
		if(quickupdate)			
			Sleep(35);
		else
		{
			printf("\a"); // beep!!!
			Sleep(200);
		}
	}
}
//==========================================================================
// Purpose: handles all of the screen information (only call if user has changed an menu item)
//==========================================================================
void Interface()
{
	ClearScreen();
	printf("\n %s%s\n\n   Main Menu - Press [#] to Use Menu\n\n\n", TITLE, LINE); // title
	printf(s_mode ? "   [1] - Mode: Client\n\n" : "   [1] - Mode: Server (Tickrate: %d ms Rating: %s) [+/-]\n\n", s_tickrate, tickrating[s_tickrate / 10]);
	if(s_mode == CLIENT)
		printf("       - Connect to IP: %s\n\n", s_ipaddress);
	printf("       - Port: %d\n\n", s_port);
	if(s_mode == SERVER)
	{
		printf(s_blackscreen ? "   [6] - [ON] Black Screens\n\n" : "   [6] - [OFF] Black Screens\n\n");
		printf(s_spawnweapon ? "   [7] - [ON] Spawn with PP7\n\n" : "   [7] - [OFF] Spawn with PP7\n\n");
		printf(s_doctorno ? "   [8] - [ON] Disable Shields\n\n" : "   [8] - [OFF] Normal Shields\n\n");
		printf(s_countdown ? "   [9] - [ON] Countdown Clock\n\n" : "   [9] - [OFF] Countdown Clock\n\n");
	}
	else
		printf("\n\n\n\n\n\n");
	printf("   [0] - Start\n\n\n");
	printf(" Note: Edit gemp.ini to change IP/Port then restart program\n%s\n", LINE);
}
//==========================================================================
// Purpose: loads settings stored in gemp.ini
// Changes Globals: s_port, s_ipaddress
//==========================================================================
void LoadSettings()
{
	FILE *fileptr = fopen("gemp.ini", "r"); // create a file pointer and open gemp.ini from same dir as our program
	if(fileptr != NULL) // if the INI exists
	{
		char line[128][128]; // char array used for file to write to
		char lines[128]; // maximum lines read size
		int counter = 0; // var is used to assign each line to a array
		while(fgets(lines, sizeof(lines), fileptr) != NULL && counter < 3) // read lines until end of file
		{
			strcpy(line[counter], lines); // read file lines and assign value to line array
			counter++; // add 1 to counter, so the next line can be read
		}
		fclose(fileptr); // close the file stream
		if(atol(line[0]) >= 1024 && atol(line[0]) <= 65534 && counter == 2)
		{
			s_port = atol(line[0]);
			strcpy(s_ipaddress, line[1]);
		}
		else
		{
			MessageBox(HWND_DESKTOP, "Loading gemp.ini failed!\n\nUnknown values detected, loading default settings.", "Error", MB_ICONERROR | MB_OK); // tell the user loading mouseinjector.ini failed
			strcpy(s_ipaddress, "192.168.0.1");
			s_port = 46102;
			SaveSettings(); // fix corrupted settings file
		}
	}
	else // if loading file failed
	{
		MessageBox(HWND_DESKTOP, "Loading gemp.ini failed!\n\nAttempting to create gemp.ini file.", "Error", MB_ICONERROR | MB_OK); // tell the user loading gemp.ini failed
		SaveSettings(); // save settings function
	}
}
//==========================================================================
// Purpose: saves current settings to gemp.ini
//==========================================================================
void SaveSettings()
{
	FILE *fileptr = fopen("gemp.ini", "w"); // create a file pointer and open gemp.ini from same dir as our program
	if(fileptr != NULL) // if INI is able to save to disk
	{
		fprintf(fileptr, "%d\n%s", s_port, s_ipaddress); // write current settings to gemp.ini
		fclose(fileptr); // close the file stream
	}
	else // if saving file failed
		MessageBox(HWND_DESKTOP, "Saving gemp.ini failed!", "Error", MB_ICONERROR | MB_OK); // tell the user saving gemp.ini failed
}
//==========================================================================
// Purpose: start network init and run server() or client()
// Changes Globals: address, self, latestmenupacket
//==========================================================================
void InitNetwork()
{
	ClearScreen();
	printf("\a"); // beep!!! (tell user we've started)
	if(enet_initialize() != 0)
		PrintError("Unable to initialize ENet", 1);
	address.port = s_port;
	if(s_mode == SERVER)
	{
		address.host = ENET_HOST_ANY;
		self = enet_host_create(&address, 1, 2, 0, 0); // address = bind the server host to, 1 = allow up to # clients and/or outgoing connections, 2 = allow up to # channels to be used, 0 = assume any amount of incoming/outgoing bandwidth
	}
	else
	{
		enet_address_set_host(&address, s_ipaddress); // connect to some.server.net:1234
		self = enet_host_create(NULL, 1, 2, 57600 / 8, 14400 / 8); // NULL = create a client host, 1 = only allow 1 outgoing connection, 2 = allow up 2 channels to be used, 57600 / 8 = 56K modem with 56 Kbps downstream bandwidth, 14400 / 8 = 56K modem with 14 Kbps upstream bandwidth
	}
	pthread_create(&manthread, NULL, Maintenance, NULL); // create thread
	if(self == NULL)
		PrintError("Unable to create a ENet client/server", 1);
	printf(s_mode ? "Client %s %u\n" : "Server %s %u\n", "started on port", address.port);
	sprintf(latestmenupacket, "0@1@2@11@0@1@5@5@0@0@1@0@0@0@0@0@0@0@0@%d@%d@%d@%d@%d", s_blackscreen, s_spawnweapon, s_doctorno, s_countdown, s_tickrate);
	InjMenu(latestmenupacket); // make sure multiplayer settings are all valid and set to default before GE-MP starts the network loop
	if(s_mode == SERVER) // server mode
		Server();
	else // client mode
		Client();
	enet_host_destroy(self); // force disconnect
	exit(EXIT_SUCCESS);
}
//==========================================================================
// Purpose: the server loop
// Changes Globals: event, peer_connected
//==========================================================================
void Server()
{
	while(SafeToInject()) // server loop
	{
		while(enet_host_service(self, &event, s_tickrate) > 0) // Keep doing host_service until no events are left
		{
			switch(event.type)
			{
				case ENET_EVENT_TYPE_CONNECT:
					printf("Player 2 has connected\nReady to play\n");
					peer_connected = 1;
					SendPacket(); // send host information
					break;
				case ENET_EVENT_TYPE_RECEIVE:
					RecvPacket(event.packet->data, event.channelID);
					enet_packet_destroy(event.packet); // Clean up the packet now that we're done using it
					break;
				case ENET_EVENT_TYPE_DISCONNECT:
					printf("Player 2 has disconected\n");
					peer_connected = 0;
					break;
			}
		}
		Hook();
	}
}
//==========================================================================
// Purpose: the client loop
// Changes Globals: peer, event, peer_connected
//==========================================================================
void Client()
{
	peer = enet_host_connect(self, &address, 2, 0); // Initiate the connection, allocating the two channels 0 and 1
	if(peer == NULL)
		PrintError("No available peers for initiating an ENet connection", 1);
	printf("Connecting to %s...\n", s_ipaddress);
	if(enet_host_service(self, &event, 5000) > 0 && event.type == ENET_EVENT_TYPE_CONNECT)
	{
		peer_connected = 1;
		printf("Connected to server succeeded\nReady to play\n");
	}
	else // connection timed out
	{
		enet_peer_reset(peer);
		PrintError("Connection to server failed", 1);
	}
	while(peer_connected && SafeToInject())
	{
		while(enet_host_service(self, &event, s_tickrate) > 0) // keep reading host_service until no events are left
		{
			switch(event.type)
			{
				case ENET_EVENT_TYPE_RECEIVE:
					RecvPacket(event.packet->data, event.channelID);
					enet_packet_destroy(event.packet); // Clean up the packet now that we're done using it
					break;
				case ENET_EVENT_TYPE_DISCONNECT:
					PrintError("Server has disconnected", 0);
					peer_connected = 0; // no longer connected to server
					break;
			}
		}
		Hook();
	}
	if(peer_connected) // if emulator was not found, and is still connected to server
	{
		enet_peer_disconnect(peer, 0); // disconnect the server
		while(enet_host_service(self, &event, 3000) > 0) // Allow up to 3 seconds for the disconnect to succeed and drop any packets received packets
		{
			switch(event.type)
			{
				case ENET_EVENT_TYPE_RECEIVE:
					enet_packet_destroy(event.packet);
					break;
				case ENET_EVENT_TYPE_DISCONNECT:
					PrintError("Disconnection succeeded", 0);
					break;
			}
		}
	}
}
//==========================================================================
// Purpose: manage the map detection functions and send to packet
//==========================================================================
void Hook()
{
	DetectStatus();
	if(maploaded || !maploaded && MenuChanged()) // if playing map or if menu has detected a change of settings
		SendPacket(); // send packet to other player
}
//==========================================================================
// Purpose: read packet and run correct injection function (menu/multi)
// Changes Globals: peer_maploaded, latestmenupacket
//==========================================================================
void RecvPacket(const char *packet, const int channel)
{
	peer_maploaded = channel; // update peer_maploaded (packet channel is used to determin if peer is in game/menu)
	if(!channel) // if peer has sent a menu update, copy packet to latestmenupacket (channel 0 is menu packets, channel 1 is game packets)
		strcpy(latestmenupacket, packet);
	if(!maploaded && !channel)
		InjMenu(packet);
	else if(maploaded && channel)
		InjMulti(packet);
}
//==========================================================================
// Purpose: gather data and send packet to other player
// Changes Globals: latestmenupacket
// Q: What's the deal with the if statement before sending?
// A: This is to check if the game has crashed or not. If the game has crashed the memory will be corrupted. GE-MP checks this with a var that it's range is known (if the vars are within a valid range, send the packet)
//==========================================================================
void SendPacket()
{
	char sendingpacket[1024];
	if(!maploaded)
	{
		int temp[19];
		temp[0] = ReadMemoryInt(GE.m_scenario, 0);
		temp[1] = ReadMemoryInt(GE.m_level, 0);
		temp[2] = ReadMemoryInt(GE.m_gamelength, 0);
		temp[3] = ReadMemoryInt(GE.m_weaponset, 0);
		temp[4] = ReadMemoryInt(GE.m_character[0], 0);
		temp[5] = ReadMemoryInt(GE.m_character[1], 0);
		temp[6] = ReadMemoryInt(GE.m_health[0], 0);
		temp[7] = ReadMemoryInt(GE.m_health[1], 0);
		temp[8] = ReadMemoryInt(GE.m_controlstyle[0], 0);
		temp[9] = ReadMemoryInt(GE.m_controlstyle[1], 0);
		temp[10] = ReadMemoryInt(GE.m_aim[2], 0);
		for(int i = 0; i < 8; i++)
			temp[11 + i] = ReadMemoryInt(GE.m_cheats[i], 0);
		sprintf(sendingpacket, "%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d", temp[0], temp[1], temp[2], temp[3], temp[4], temp[5], temp[6], temp[7], temp[8], temp[9], temp[10], temp[11], temp[12], temp[13], temp[14], temp[15], temp[16], temp[17], temp[18], s_blackscreen, s_spawnweapon, s_doctorno, s_countdown, s_tickrate);
		strcpy(latestmenupacket, sendingpacket);
	}
	else
	{
		int inttemp[12], gunarray[11];
		float floattemp[10];
		if(!ReadMemoryInt(GE.mp_freeze, 0) && (!ReadMemoryInt(playerbase[s_mode], GE.mp_start) && !ReadMemoryInt(playerbase[s_mode], GE.mp_deathflag) || ReadMemoryFloat(playerbase[s_mode], GE.mp_startrespawn) > 50 && ReadMemoryInt(playerbase[s_mode], GE.mp_deathflag == 2))) // if start menu is closed or if player has finished death animation, send input
			inttemp[0] = ReadMemoryInt(GE.controller[s_mode], 0);
		else // if player is viewing start menu or if player has not finished death animation, send no input
			inttemp[0] = 0; // no input
		inttemp[1] = ReadMemoryInt(playerbase[s_mode], 0);
		inttemp[2] = ReadMemoryInt(playerbase[!s_mode], GE.mp_deathflag);
		floattemp[0] = ReadMemoryFloat(playerbase[s_mode], GE.mp_camx);
		floattemp[1] = ReadMemoryFloat(playerbase[s_mode], GE.mp_camy);
		floattemp[2] = ReadMemoryFloat(playerbase[s_mode], GE.mp_xpos);
		floattemp[3] = ReadMemoryFloat(playerbase[s_mode], GE.mp_ypos);
		floattemp[4] = ReadMemoryFloat(playerbase[s_mode], GE.mp_zpos);
		inttemp[3] = ReadMemoryInt(playerbase[s_mode], GE.mp_portalid);
		if(s_mode == SERVER && ReadMemoryInt(GE.m_gamelength, 0) >= 1 && ReadMemoryInt(GE.m_gamelength, 0) <= 3) // only send time information if settings require time sync (don't waste packet size)
			inttemp[4] = ReadMemoryInt(GE.time, 0) / 60;
		else
			inttemp[4] = 0;
		inttemp[5] = ReadMemoryInt(playerbase[s_mode], GE.mp_weaponammo);
		inttemp[6] = ReadMemoryInt(playerbase[s_mode], GE.mp_weaponmodel);
		inttemp[7] = ReadMemoryInt(playerbase[s_mode], GE.mp_weaponfunction);
		if(inttemp[6] >= 4 && inttemp[6] <= 21 || inttemp[6] == 24 || inttemp[6] == 25 || inttemp[6] == 31)
			inttemp[8] = ReadMemoryInt(playerbase[s_mode], GE.mp_totalammo[AmmoType(inttemp[6])]);
		inttemp[9] = ReadMemoryInt(GE.mp_scorekill[s_mode], 0);
		inttemp[10] = ReadMemoryInt(GE.mp_scoredeath[!s_mode], 0);
		inttemp[11] = ReadMemoryInt(GE.mp_scoresuicide[!s_mode], 0);
		floattemp[5] = ReadMemoryFloat(playerbase[!s_mode], GE.mp_startrespawn);
		floattemp[6] = ReadMemoryFloat(playerbase[!s_mode], GE.mp_health);
		floattemp[7] = ReadMemoryFloat(playerbase[!s_mode], GE.mp_shield);
		floattemp[8] = ReadMemoryFloat(playerbase[s_mode], GE.mp_crosshairx);
		floattemp[9] = ReadMemoryFloat(playerbase[s_mode], GE.mp_crosshairy);
		for(int i = 0; i < 11; i++) // read the first 10 items in the player's inventory
		{
			if(ReadMemoryInt(INVENTORYPOINTER(s_mode), i * 0x14) == 1) // check and see if weapon slot in memory contains a weapon
				gunarray[i] = ReadMemoryInt(INVENTORYPOINTER(s_mode), i * 0x14 + 0x4); // read slot's weapon id and set to gunarray[i]
			else
				gunarray[i] = NOGUN; // no gun, set to magic number
		}
		sprintf(sendingpacket, "%d@%d@%d@%1.3f@%1.3f@%1.4f@%1.4f@%1.4f@%d@%d@%d@%d@%d@%d@%d@%d@%d@%1.2f@%1.4f@%1.2f@%1.1f@%1.1f@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d", inttemp[0], inttemp[1], inttemp[2], floattemp[0], floattemp[1], floattemp[2], floattemp[3], floattemp[4], inttemp[3], inttemp[4], inttemp[5], inttemp[6], inttemp[7], inttemp[8], inttemp[9], inttemp[10], inttemp[11], floattemp[5], floattemp[6], floattemp[7], floattemp[8], floattemp[9], gunarray[0], gunarray[1], gunarray[2], gunarray[3], gunarray[4], gunarray[5], gunarray[6], gunarray[7], gunarray[8], gunarray[9], gunarray[10], spawned);
	}
	ENetPacket* packet = enet_packet_create(sendingpacket, strlen(sendingpacket) + 1, ENET_PACKET_FLAG_RELIABLE);
	if(ReadMemoryInt(GE.m_level, 0) >= 0 && ReadMemoryInt(GE.m_level, 0) <= 11 && ReadMemoryInt(GE.m_controlstyle[0], 0) >= 0 && ReadMemoryInt(GE.m_controlstyle[0], 0) <= 7 && ReadMemoryInt(GE.m_controlstyle[1], 0) >= 0 && ReadMemoryInt(GE.m_controlstyle[1], 0) <= 7) // check to see if game data is valid (has not crashed) before sending, so other peer does not crash (I'm a horrible coder)
	{
		if(s_mode == SERVER)
			enet_host_broadcast(self, maploaded, packet); // can't use enet_peer_send for server, it crashes for some reason, investigate this later
		else
			enet_peer_send(peer, maploaded, packet);
	}
}
//==========================================================================
// Purpose: keep game status stable and consistant
// TODO: Rewrite everything in this function, as it is currently messy
//==========================================================================
void *Maintenance()
{
	while(!closethread)
	{
		if(!maploaded)
		{
			WriteMemoryInt(GE.controllersconnected, 0x03000000, 0); // always force 2 players to be connected
			WriteMemoryInt(GE.m_selectablecharacters, 64, 0); // always allow player to select all characeters (including staff)
			WriteMemoryInt(GE.rng, 0, 0); // keep RNG disabled until players have spawned, or else clients may spawn on top of eachother or very close to eachother
			WriteMemoryInt(GE.m_players, 2, 0); // always show 2 players on multi menu
			WriteMemoryInt(GE.m_title[0], 1195715917, 0); // change multiplayer string to GE-MP
			WriteMemoryInt(GE.m_title[1], 1229999169, 0);
			WriteMemoryInt(GE.m_title[2], 1349922862, 0);
			WriteMemoryInt(GE.m_title[3], 1228283949, 0);
			if(peer_connected) // change option string to ready
			{
				WriteMemoryInt(GE.m_title[4], 538989125, 0);
				WriteMemoryInt(GE.m_title[5], 4277337, 0);
			}
			else // change option string to offline
			{
				WriteMemoryInt(GE.m_title[4], 1330005580, 0);
				WriteMemoryInt(GE.m_title[5], 4804165, 0);
			}
			if(ReadMemoryInt(GE.m_page, 0) >= 15 && ReadMemoryInt(GE.m_page, 0) <= 17) // user is in health/character/control style menus
				WriteMemoryInt(GE.m_lock[!s_mode], 1, 0); // lock other player's choice
			if(s_mode == SERVER) // lock menu for server until client has connected
			{
				if(!peer_connected)
					for(int i = 0; i < 7; i++)
						WriteMemoryInt(GE.m_freeze[i], 0, 0); // disable if required to be frozen
				else if(!ReadMemoryInt(GE.m_freeze[1], 0)) // if menu has been frozen and client has connected unfreeze menu (menu item scenario cannot be frozen by game so GE-MP uses this as a flag for checking to see if the menu is still frozen)
					for(int i = 0; i < 7; i++)
						if(ReadMemoryInt(GE.m_scenario, 0) == 1 && i == 1 || ReadMemoryInt(GE.m_scenario, 0) == 3 && i == 2 || ReadMemoryInt(GE.m_scenario, 0) == 4 && i == 4) // don't freeze/unfreeze some menu items if they are required to be frozen by scenario
							WriteMemoryInt(GE.m_freeze[i], 0, 0); // disable if required to be frozen
						else
							WriteMemoryInt(GE.m_freeze[i], 1, 0); // enable if not required to be frozen
			}
		}
		if(s_mode == CLIENT) // server controls the current game mode (if client doesn't follow, force game to revert to menu/in-game)
		{
			if(maploaded && !peer_maploaded) // exit round automatically if host is reported to be still in the menu
				WriteMemoryInt(GE.camera, 10, 0); // return to menu
			else if(!maploaded && peer_maploaded) // start round automatically if host has already started the match
				StartRound();
			const int page = ReadMemoryInt(GE.m_page, 0);
			if(!maploaded && !peer_maploaded && !(page == 5 || page >= 7 && page <= 10 || page == 12 || page == 13 || page >= 15 && page <= 17)) // remap P2 controls to P1 only if player is in 'safe' menus (see SafeToInject())
				WriteMemoryInt(GE.controller[!s_mode], ReadMemoryInt(GE.controller[s_mode], 0), 0);
			if(maploaded && !ReadMemoryInt(GE.mp_matchended, 0) && (ReadMemoryInt(playerbase[s_mode], GE.mp_startmenupage) >= 4 && ReadMemoryInt(playerbase[s_mode], GE.mp_startmenupage) <= 6)) // disable client from quitting (server controls when to quit)
				WriteMemoryInt(playerbase[s_mode], 3, GE.mp_startmenupage); // set menu back to default
		}
		if(maploaded) // if map has loaded up
		{
			if(!ReadMemoryInt(GE.mp_matchended, 0)) // if match has not ended, disable pause
			{
				WriteMemoryInt(GE.pause[0], 0, 0);
				WriteMemoryInt(GE.pause[1], 0, 0);
			}
			if(s_mode == SERVER && (ReadMemoryInt(GE.mp_matchended, 0) == 1 && ReadMemoryInt(playerbase[s_mode], GE.mp_start) == 1 && ReadMemoryInt(playerbase[s_mode], GE.mp_startmenupage) == 7 || !peer_connected)) // if P1 has closed their stats menu after round has finished or if client has not connected yet
				WriteMemoryInt(GE.camera, 10, 0); // return to menu
			if(!ReadMemoryInt(GE.mp_matchended, 0)) // if user is not viewing the start menu, keep start menus locked up
			{
				WriteMemoryInt(playerbase[!s_mode], 0, GE.mp_start); // always ready to quit
				WriteMemoryInt(playerbase[!s_mode], 7, GE.mp_startmenupage); // always ready to quit
			}
			else if(ReadMemoryInt(GE.pause[0], 0) == 1 && ReadMemoryInt(GE.pause[1], 0) == 1) // if match has ended, let user see other player's start menu
			{
				WriteMemoryInt(playerbase[!s_mode], 1, GE.mp_start);
				WriteMemoryInt(playerbase[!s_mode], ReadMemoryInt(playerbase[s_mode], GE.mp_startmenupage), GE.mp_startmenupage);
			}
		}
		if(spawned) // if player has spawned in map
		{
			if(s_blackscreen) // if black screen is enabled, block other player's screen
			{
				WriteMemoryInt(playerbase[!s_mode], 0, GE.mp_rgba[0]); // red
				WriteMemoryInt(playerbase[!s_mode], 0, GE.mp_rgba[1]); // green
				WriteMemoryInt(playerbase[!s_mode], 0, GE.mp_rgba[2]); // blue
				WriteMemoryFloat(playerbase[!s_mode], 1, GE.mp_rgba[3]); // alpha
			}
			if(s_doctorno) // if doctor no is enabled (no shields mode)
			{
				WriteMemoryFloat(playerbase[!s_mode], 0, GE.mp_shield);
				WriteMemoryFloat(playerbase[s_mode], 0, GE.mp_shield);
			}
			WriteMemoryInt(GE.controller[!s_mode], peer_lastinput, 0); // inject last recv input into game (makes other player's input more fluid)
			if(!ReadMemoryInt(playerbase[s_mode], GE.mp_deathflag)) // if player is alive, turn on local player's invulnerability (damage is controlled by other client)
				WriteMemoryInt(playerbase[s_mode], 0x0F, GE.mp_invulnerable);
			if(peer_deathflag && ReadMemoryFloat(playerbase[s_mode], GE.mp_startrespawn) > 50 && !ReadMemoryInt(GE.mp_freeze, 0)) // if remote peer is dying, disable press start from showing up
				WriteMemoryFloat(playerbase[s_mode], 55, GE.mp_startrespawn);
			else if(!peer_deathflag && ReadMemoryInt(playerbase[s_mode], GE.mp_deathflag) == 2 && ReadMemoryFloat(playerbase[s_mode], GE.mp_startrespawn) > 50) // if my character on peer's side has spawned, and waiting for press start on my side, force spawn
			{
				WriteMemoryFloat(playerbase[s_mode], 60, GE.mp_startrespawn);
				WriteMemoryInt(GE.controller[s_mode], 0x80000000, 0);
				if(s_spawnweapon) // if spawn weapon is enabled, add PP7 into inventory
					GiveWeapon(4); // add PP7 to player's inventory
			}
			if(s_countdown && ReadMemoryInt(GE.m_gamelength, 0) >= 1 && ReadMemoryInt(GE.m_gamelength, 0) <= 3 && ReadMemoryInt(GE.m_page, 0) == 11 && !ReadMemoryInt(GE.mp_matchended, 0)) // if countdown is enable and game length setting is time based and match has not ended, show clock
			{
				int time = ReadMemoryInt(GE.time, 0); // get time
				if(ReadMemoryInt(GE.m_gamelength, 0) == 1) // 5 minute match
					time = 5 * 3600 - time; // calculate time remaining
				else if(ReadMemoryInt(GE.m_gamelength, 0) == 2) // 10 minute match
					time = 10 * 3600 - time;
				else // 20 minute match
					time = 20 * 3600 - time;
				if(time >= 0 && time <= 600 || time >= 3300 && time <= 3600 || time >= 10500 && time <= 10800 || time >= 17700 && time <= 18000 && ReadMemoryInt(GE.m_gamelength, 0) != 1 || time >= 35700 && time <= 36000 && ReadMemoryInt(GE.m_gamelength, 0) != 2 || time >= 53700 && time <= 54000) // show clock at 10 seconds, 1 minute, 3 minutes, 5 minutes, 10 minutes, 15 minutes
				{
					WriteMemoryInt(GE.showclock, 0, 0); // show clock
					WriteMemoryFloat(GE.clock, time, 0); // update clock
				}
				else
					WriteMemoryInt(GE.showclock, 9, 0); // hide clock
			}
		}
		Sleep(1);
	}
	return NULL;
}
//==========================================================================
// Purpose: inject menu packet
// Changes Globals: s_blackscreen, s_spawnweapon, s_doctorno, s_countdown, s_tickrate
//==========================================================================
void InjMenu(const char *packet)
{
	int temp[24], aim[4] = {0, 1, 256, 257};
	sscanf(packet, "%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d", &temp[0], &temp[1], &temp[2], &temp[3], &temp[4], &temp[5], &temp[6], &temp[7], &temp[8], &temp[9], &temp[10], &temp[11], &temp[12], &temp[13], &temp[14], &temp[15], &temp[16], &temp[17], &temp[18], &temp[19], &temp[20], &temp[21], &temp[22], &temp[23]);
	WriteMemoryInt(GE.m_scenario, temp[0], 0);
	for(int i = 0; i < 7; i++)
		if(temp[0] == 1 && i == 1 || temp[0] == 3 && i == 2 || temp[0] == 4 && i == 4) // don't freeze/unfreeze some menu items if they are required to be frozen by scenario
			WriteMemoryInt(GE.m_freeze[i], 0, 0); // disable if required to be frozen
		else
			WriteMemoryInt(GE.m_freeze[i], 1, 0); // enable if not required to be frozen
	WriteMemoryInt(GE.m_level, temp[1], 0);
	WriteMemoryInt(GE.m_gamelength, temp[2], 0);
	WriteMemoryInt(GE.m_weaponset, temp[3], 0);
	WriteMemoryInt(GE.m_character[0], temp[4], 0);
	WriteMemoryInt(GE.m_character[1], temp[5], 0);
	WriteMemoryInt(GE.m_characterscroll[!s_mode], temp[4], 0); // only inject other player's character (this is to prevent our player's wheel from auto scrolling, which gets annoying if you're selecting your character)
	WriteMemoryInt(GE.m_health[0], temp[6], 0);
	WriteMemoryInt(GE.m_health[1], temp[7], 0);
	WriteMemoryInt(GE.m_controlstyle[0], temp[8], 0);
	WriteMemoryInt(GE.m_controlstyle[1], temp[9], 0);
	WriteMemoryInt(GE.m_aim[0], aim[temp[10]], 0);
	WriteMemoryInt(GE.m_aim[1], aim[temp[10]], 0);
	WriteMemoryInt(GE.m_aim[2], temp[10], 0);
	int cheatcheck = 0;
	for(int i = 0; i < 8; i++)
	{
		WriteMemoryInt(GE.m_cheats[i], temp[11 + i], 0);
		if(temp[11 + i] != 0 && !cheatcheck)
			cheatcheck = 1;
		WriteMemoryInt(GE.m_cheats[8], cheatcheck, 0);
		WriteMemoryInt(GE.m_cheats[9], cheatcheck, 0);
	}
	if(s_mode == CLIENT) // server controls tickrate and shield settings
	{
		s_blackscreen = temp[19];
		s_spawnweapon = temp[20];
		s_doctorno = temp[21];
		s_countdown = temp[22];
		s_tickrate = temp[23];
	}
}
//==========================================================================
// Purpose: inject multiplayer packet
// Changes Globals: peer_deathflag
//==========================================================================
void InjMulti(const char *packet)
{
	int inttemp[12], gunarray[11], peer_spawned = 0;
	float floattemp[10];
	sscanf(packet, "%d@%d@%d@%f@%f@%f@%f@%f@%d@%d@%d@%d@%d@%d@%d@%d@%d@%f@%f@%f@%f@%f@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d", &inttemp[0], &inttemp[1], &inttemp[2], &floattemp[0], &floattemp[1], &floattemp[2], &floattemp[3], &floattemp[4], &inttemp[3], &inttemp[4], &inttemp[5], &inttemp[6], &inttemp[7], &inttemp[8], &inttemp[9], &inttemp[10], &inttemp[11], &floattemp[5], &floattemp[6], &floattemp[7], &floattemp[8], &floattemp[9], &gunarray[0], &gunarray[1], &gunarray[2], &gunarray[3], &gunarray[4], &gunarray[5], &gunarray[6], &gunarray[7], &gunarray[8], &gunarray[9], &gunarray[10], &peer_spawned);
	if(peer_spawned && !ReadMemoryInt(GE.mp_matchended, 0)) // if peer has spawned and match is still active
	{
		WriteMemoryInt(GE.controller[!s_mode], inttemp[0], 0);
		peer_lastinput = inttemp[0];
		WriteMemoryInt(playerbase[!s_mode], inttemp[1], 0);
		if(inttemp[2] != 0 && !peer_deathflag)
		{
			for(int i = 0; i < 11; i++) // clear inventory
				WriteMemoryInt(INVENTORYPOINTER(s_mode), 0xFFFFFFFF, i * 0x14);
			WriteMemoryInt(playerbase[s_mode], 1, GE.mp_deathflag);
			peer_deathflag = 1;
		}
		else if(inttemp[2] == 0 && peer_deathflag && floattemp[5] == -1)
			peer_deathflag = 0;
		WriteMemoryFloat(playerbase[!s_mode], floattemp[0], GE.mp_camx);
		WriteMemoryFloat(playerbase[!s_mode], floattemp[1], GE.mp_camy);
		WriteMemoryFloat(playerbase[!s_mode], floattemp[2], GE.mp_xpos);
		WriteMemoryFloat(playerbase[!s_mode], floattemp[3], GE.mp_ypos);
		WriteMemoryFloat(playerbase[!s_mode], floattemp[4], GE.mp_zpos);
		WriteMemoryInt(playerbase[!s_mode], inttemp[3], GE.mp_portalid);
		if(s_mode == CLIENT && ReadMemoryInt(GE.m_gamelength, 0) >= 1 && ReadMemoryInt(GE.m_gamelength, 0) <= 3 && inttemp[4] != ReadMemoryInt(GE.time, 0) / 60) // slave to server clock (only inject if game length setting is time based)
			WriteMemoryInt(GE.time, inttemp[4] * 60 - 1, 0);
		if(inttemp[5] > 0) // don't inject ammo if ammo is 0 or else GE-MP will encounter glitches for 1 bullet guns (e.g: rlaunchers don't fire)
			WriteMemoryInt(playerbase[!s_mode], inttemp[5], GE.mp_weaponammo);
		WriteMemoryInt(playerbase[!s_mode], inttemp[6], GE.mp_weaponmodel);
		WriteMemoryInt(playerbase[!s_mode], inttemp[7], GE.mp_weaponfunction);
		if(inttemp[6] >= 4 && inttemp[6] <= 21 || inttemp[6] == 24 || inttemp[6] == 25 || inttemp[6] == 31)
			WriteMemoryInt(playerbase[!s_mode], inttemp[8], GE.mp_totalammo[AmmoType(inttemp[7])]);
		WriteMemoryInt(GE.mp_scorekill[!s_mode], inttemp[9], 0);
		WriteMemoryInt(GE.mp_scoredeath[s_mode], inttemp[10], 0);
		WriteMemoryInt(GE.mp_scoresuicide[s_mode], inttemp[11], 0);
		if(ReadMemoryFloat(playerbase[s_mode], GE.mp_health) != floattemp[6] || ReadMemoryFloat(playerbase[s_mode], GE.mp_shield) != floattemp[7] && !s_doctorno) // if player was shot, simulate hurt effects
		{
			WriteMemoryFloat(playerbase[s_mode], floattemp[6], GE.mp_health); // update player's health from peer data
			WriteMemoryFloat(playerbase[s_mode], floattemp[7], GE.mp_shield); // update player's shield from peer data
			WriteMemoryFloat(playerbase[s_mode], floattemp[6], GE.mp_hudhealth); // update hud health value
			WriteMemoryFloat(playerbase[s_mode], floattemp[7], GE.mp_hudshield); // update hud shield value
			WriteMemoryInt(playerbase[s_mode], 50, GE.mp_showhud); // show health/shield
			const float pushrotation = Direction(ReadMemoryFloat(playerbase[s_mode], GE.mp_xpos), ReadMemoryFloat(playerbase[s_mode], GE.mp_zpos), floattemp[2], floattemp[4]);
			WriteMemoryFloat(playerbase[s_mode], 2 * sinf(pushrotation / 57.29578), GE.mp_pushx); // push player away from peer
			WriteMemoryFloat(playerbase[s_mode], 2 * -cosf(pushrotation / 57.29578), GE.mp_pushy); // push player away from peer
		}
		WriteMemoryFloat(playerbase[!s_mode], floattemp[8], GE.mp_crosshairx);
		WriteMemoryFloat(playerbase[!s_mode], floattemp[9], GE.mp_crosshairy);
		SortArray(gunarray, sizeof gunarray / sizeof gunarray[0]); // rearrange array from 1 to 99
		for(int i = 0; i < 11; i++)
			if(gunarray[i] != NOGUN)
			{
				WriteMemoryInt(INVENTORYPOINTER(!s_mode), 1, i * 0x14); // write to slot's flag (set to enable)
				WriteMemoryInt(INVENTORYPOINTER(!s_mode), gunarray[i], i * 0x14 + 0x4);
				if(gunarray[i + 1] != NOGUN)
					WriteMemoryInt(INVENTORYPOINTER(!s_mode), INVENTORYPOINTER(!s_mode) + 0x80000000 + (i + 1) * 0x14, i * 0x14 + 0xC); // next weapon pointer
				else
					WriteMemoryInt(INVENTORYPOINTER(!s_mode), INVENTORYPOINTER(!s_mode) + 0x80000000, i * 0x14 + 0xC); // next weapon pointer (this points back to the first gun (or slapper), since we're at the end of the gun array)
				if(i != 0) // if weapon is not the first in the array
					WriteMemoryInt(INVENTORYPOINTER(!s_mode), INVENTORYPOINTER(!s_mode) + 0x80000000 + (i - 1) * 0x14, i * 0x14 + 0x10); // prev weapon pointer
				else for(int j = 0; j < 11; j++) // sort through all weapons
					if(gunarray[j] != NOGUN) // exec this until it has stopped at the last weapon or end of the array
						WriteMemoryInt(INVENTORYPOINTER(!s_mode), INVENTORYPOINTER(!s_mode) + 0x80000000 + j * 0x14, 0x10); // prev weapon pointer (this points the previous weapon to the highest weapon id, since we're at the start of the array)
			}
			else
				WriteMemoryInt(INVENTORYPOINTER(!s_mode), 0xFFFFFFFF, i * 0x14);
	}
}
//==========================================================================
// Purpose: compare last packet to current multi settings (if true, send our changes to other player)
// Q: What's the deal with "ReadMemoryInt(GE.m_page, 0) != 5"?
// A: If value from GE.m_page == 5 then player has quit to the profile menu, which resets settings. I consider this as an accidental menu change so return 0. SafeToInject() will force player to return to the main menu and will inject the last recv peer message
//==========================================================================
int MenuChanged()
{
	char compare[1024];
	int temp[19];
	if(ReadMemoryInt(GE.m_controlstyle[0], 0) > 3 || ReadMemoryInt(GE.m_controlstyle[1], 0) > 3) // if user has changed control style to unsupported style (2.x), reset to last settings
		InjMenu(latestmenupacket);
	if(ReadMemoryInt(GE.m_level, 0) == 0) // if user has changed level to "random", generate random number and set map
	{
		srand(time(NULL));
		WriteMemoryInt(GE.m_level, rand() % 10 + 1, 0);
	}
	temp[0] = ReadMemoryInt(GE.m_scenario, 0);
	temp[1] = ReadMemoryInt(GE.m_level, 0);
	temp[2] = ReadMemoryInt(GE.m_gamelength, 0);
	temp[3] = ReadMemoryInt(GE.m_weaponset, 0);
	temp[4] = ReadMemoryInt(GE.m_character[0], 0);
	temp[5] = ReadMemoryInt(GE.m_character[1], 0);
	temp[6] = ReadMemoryInt(GE.m_health[0], 0);
	temp[7] = ReadMemoryInt(GE.m_health[1], 0);
	temp[8] = ReadMemoryInt(GE.m_controlstyle[0], 0);
	temp[9] = ReadMemoryInt(GE.m_controlstyle[1], 0);
	temp[10] = ReadMemoryInt(GE.m_aim[2], 0);
	for(int i = 0; i < 8; i++)
		temp[11 + i] = ReadMemoryInt(GE.m_cheats[i], 0);
	sprintf(compare, "%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d@%d", temp[0], temp[1], temp[2], temp[3], temp[4], temp[5], temp[6], temp[7], temp[8], temp[9], temp[10], temp[11], temp[12], temp[13], temp[14], temp[15], temp[16], temp[17], temp[18], s_blackscreen, s_spawnweapon, s_doctorno, s_countdown, s_tickrate);
	if(strcmp(compare, latestmenupacket) != 0 && ReadMemoryInt(GE.m_page, 0) != 5) // if latestmenupacket from peer is different to the current settings, then menu has been changed (return 1)
		return 1;
	return 0;
}
//==========================================================================
// Purpose: force game to start round
//==========================================================================
void StartRound()
{
	InjMenu(latestmenupacket); // input last recv message before starting round for client
	if(ReadMemoryInt(GE.m_page, 0) >= 14 && ReadMemoryInt(GE.m_page, 0) <= 20) // user is in multiplayer's sub-menus
		WriteMemoryInt(GE.m_page, 14, 0);
	if(ReadMemoryInt(GE.m_page, 0) == 21) // user is in cheat menu
	{
		WriteMemoryInt(GE.controller[0], 0x40000000, 0);
		Sleep(50);
	}
	if(ReadMemoryInt(GE.m_page, 0) == 6 || ReadMemoryInt(GE.m_page, 0) == 21) // user is in main menu
	{
		WriteMemoryFloat(GE.m_crosshairx, 200, 0);
		WriteMemoryFloat(GE.m_crosshairy, 256, 0);
		WriteMemoryInt(GE.controller[0], 0x80000000, 0); // hit A on multiplayer option (assuming more then 2 controllers are plugged in)
		Sleep(50); // wait for page to load
	}
	WriteMemoryInt(GE.m_start[0], 1, 0); // set these flags to 1 to trigger the load map system
	WriteMemoryInt(GE.m_start[1], 1, 0);
	Sleep(100); // wait for round to load
}
//==========================================================================
// Purpose: adds weapon to player's inventory
//==========================================================================
void GiveWeapon(const int weapon)
{
	Sleep(20);
	WriteMemoryInt(INVENTORYPOINTER(s_mode), 1, 10 * 0x14); // write to the 10th weapon slot's flag (set to enable)
	WriteMemoryInt(INVENTORYPOINTER(s_mode), weapon, 10 * 0x14 + 0x4); // write PP7 into the 10th weapon slot's weapon id (in case player spawn on unrespawnable items such as the flag or GG, write to the end of the array so it does not overwrite any weapons)
	WriteMemoryInt(playerbase[s_mode], 21, GE.mp_totalammo[AmmoType(weapon)]); // give weapon some ammo
	int gunarray[11];
	for(int i = 0; i < 11; i++) // read the first 10 items in the player's inventory
	{
		if(ReadMemoryInt(INVENTORYPOINTER(s_mode), i * 0x14) == 1) // check and see if weapon slot in memory contains a weapon
			gunarray[i] = ReadMemoryInt(INVENTORYPOINTER(s_mode), i * 0x14 + 0x4); // read slot's weapon id and set to gunarray[i]
		else
			gunarray[i] = NOGUN; // no gun, set to magic number
	}
	SortArray(gunarray, sizeof gunarray / sizeof gunarray[0]); // rearrange array from 1 to 99
	for(int i = 0; i < 11; i++)
		if(gunarray[i] != NOGUN)
		{
			WriteMemoryInt(INVENTORYPOINTER(s_mode), 1, i * 0x14); // write to slot's flag (set to enable)
			WriteMemoryInt(INVENTORYPOINTER(s_mode), gunarray[i], i * 0x14 + 0x4);
			if(gunarray[i + 1] != NOGUN)
				WriteMemoryInt(INVENTORYPOINTER(s_mode), INVENTORYPOINTER(s_mode) + 0x80000000 + (i + 1) * 0x14, i * 0x14 + 0xC); // next weapon pointer
			else
				WriteMemoryInt(INVENTORYPOINTER(s_mode), INVENTORYPOINTER(s_mode) + 0x80000000, i * 0x14 + 0xC); // next weapon pointer (this points back to the first gun (or slapper), since we're at the end of the gun array)
			if(i != 0) // if weapon is not the first in the array
				WriteMemoryInt(INVENTORYPOINTER(s_mode), INVENTORYPOINTER(s_mode) + 0x80000000 + (i - 1) * 0x14, i * 0x14 + 0x10); // prev weapon pointer
			else for(int j = 0; j < 11; j++) // sort through all weapons
				if(gunarray[j] != NOGUN) // exec this until it has stopped at the last weapon or end of the array
					WriteMemoryInt(INVENTORYPOINTER(s_mode), INVENTORYPOINTER(s_mode) + 0x80000000 + j * 0x14, 0x10); // prev weapon pointer (this points the previous weapon to the highest weapon id, since we're at the start of the array)
		}
		else
			WriteMemoryInt(INVENTORYPOINTER(s_mode), 0xFFFFFFFF, i * 0x14);
}
//==========================================================================
// Purpose: detect what memory group the map is active in, as well as detecting when player has spawned or is in menu
// Changes Globals: maploaded, spawned
//==========================================================================
void DetectStatus()
{
	if(!maploaded && ReadMemoryInt(GE.m_page, 0) == 11 && ReadMemoryInt(GE.camera, 0) == 9) // if game has switched from menu to in-game (wait for player to zoom into character)
	{
		maploaded = 1;
		if(s_mode == SERVER)
			SendPacket(); // send start packet
		WriteMemoryInt(GE.rng, 1, 0);
	}
	if(maploaded && !spawned && ReadMemoryInt(GE.camera, 0) == 0) // if user is in control of character
	{
		int pointerdump[64];
		for(int i = 0; i < 64; i++)
		{
			pointerdump[i] = ReadMemoryInt(ReadMemoryInt(0x8007A0B0 - 0x80000000, 0), 0) - 0x80000000 + 0x9C;
			Sleep(1);
		}
		SortArray(pointerdump, sizeof pointerdump / sizeof pointerdump[0]);
		playerbase[0] = pointerdump[0];
		for(int j = 1; j < 64; j++)
			if(pointerdump[j - 1] != pointerdump[j]) // search pointerdump array until it finds P2's pointer
			{
				playerbase[1] = pointerdump[j];
				break;
			}
		spawned = 1;
		if(s_spawnweapon) // if spawn weapon is enabled
			GiveWeapon(4); // add PP7 to player's inventory
	}
	if(maploaded && ReadMemoryInt(GE.m_page, 0) != 11) // if game has switched from in-game to menu
	{
		maploaded = 0;
		spawned = 0;
		peer_deathflag = 0;
		peer_lastinput = 0;
		if(s_mode == SERVER)
			SendPacket(); // send menu packet
	}
}
//==========================================================================
// Purpose: return a value, which is used to see if game is safe to inject (also stops user from using the SP menu)
// Q: what does page mean?
// A: page is a number which is used to display menu pages, as well as current game status
// Below is a table of the page range IDs:
// -1 = unknown but important for map restarts
// 0 = start
// 1 = logo
// 2 = logo
// 3 = barrel intro
// 4 = game title
// 5 = save profile menu
// 6 = main menu
// 7 = sp menu
// 8 = mission difficulty
// 9 = 007 difficulty
// 10 = mission objectives and briefing
// 11 = in game (sp & mp)
// 12 = mission objective results
// 13 = mission detail results
// 14 = mp menu
// 15 = mp character
// 16 = mp health
// 17 = mp control style
// 18 = mp level menu
// 19 = mp scenario
// 20 = mp scenario team selection
// 21 = cheats
// 22 = no controller in socket message
// 23 = start map flag
//==========================================================================
int SafeToInject()
{
	if(EmulatorDetected()) // don't bother checking the menu flag if emulator isn't running
	{
		const int camera = ReadMemoryInt(GE.camera, 0), page = ReadMemoryInt(GE.m_page, 0), pause1 = ReadMemoryInt(GE.pause[0], 0), pause2 = ReadMemoryInt(GE.pause[1], 0), matchended = ReadMemoryInt(GE.mp_freeze, 0), exit = ReadMemoryInt(GE.exit, 0);
		const float crosshairx = ReadMemoryFloat(GE.m_crosshairx, 0), crosshairy = ReadMemoryFloat(GE.m_crosshairy, 0);
		if(camera >= 0 && camera <= 10 && page >= -1 && page <= 25 && pause1 >= 0 && pause1 <= 1 && pause2 >= 0 && pause2 <= 1 && matchended >= 0 && matchended <= 1 && exit >= 0 && exit <= 1 && crosshairx >= 20 && crosshairx <= 420 && crosshairy >= 20 && crosshairy <= 310) // if GoldenEye is running
		{
			if(page >= 7 && page <= 10 || page == 12 || page == 13)
			{
				WriteMemoryInt(GE.controller[0], 0x40000000, 0); // emulate P1 pressing the B button
				Sleep(20); // wait for input to be injected
				return 1; // assumes user is injectable now that user isn't in the SP menu anymore
			}
			if(page == 5) // if user has exited main menu and is in the saved profile menu
			{
				WriteMemoryInt(GE.controller[0], 0x80000000, 0); // enter profile
				Sleep(50); // wait for page to load
				InjMenu(latestmenupacket);
				return 1;
			}
			if(page == 6 || page == 11 || page >= 14 && page <= 21 || page >= 23 || page == -1)
				return 1; // safe to inject
			PrintError("GoldenEye 007 is not in menu", 0); // if we're here, it means user is not in correct menu
			return 0;
		}
		else // if GoldenEye was not found
			PrintError("Emulator not running GoldenEye 007 (U) [!]", 0);
	}
	return 0;
}
//==========================================================================
// Purpose: returns a number that is used to access GE.mp_totalammo[#]
//==========================================================================
int AmmoType(const int weaponid)
{
	if(weaponid == 8 || weaponid == 13 || weaponid == 17)
		return 1; // KF7 Ammo
	else if(weaponid == 24)
		return 2; // Grenade Launcher Ammo
	else if(weaponid == 25)
		return 3; // Rocket Launcher Ammo
	else if(weaponid == 15 || weaponid == 16)
		return 4; // Shotgun Ammo
	else if(weaponid == 18)
		return 5; // Magnum Ammo
	else if(weaponid == 19)
		return 6; // Golden Bullets
	else if(weaponid == 31)
		return 7; // Tank Ammo
	return 0; // Pistol Ammo (default)
}
//==========================================================================
// Purpose: sorting function for inventory array
//==========================================================================
void SortArray(int *a, const int n)
{
	if(n < 2)
		return;
	int p = a[n / 2];
	int *l = a;
	int *r = a + n - 1;
	while(l <= r)
	{
		while(*l < p)
			l++;
		while(*r > p)
			r--;
		if(l <= r)
		{
			int t = *l;
			*l++ = *r;
			*r-- = t;
		}
	}
	SortArray(a, r - a + 1);
	SortArray(l, a + n - l);
}
//==========================================================================
// Purpose: give direction to player (used for emulating hurt push)
//==========================================================================
float Direction(const float localx, const float localy, const float peerx, const float peery)
{
	float xdif, ydif, rotation;
	if(peerx >= localx && peery > localy) // Sec 1 North-West of our position
	{
		xdif = localx - peerx;
		ydif = peery - localy;
		rotation = atan(xdif/ydif) * 57.29578;
	}
	else if(peerx > localx && peery <= localy) // Sec 2 South-West of our position
	{
 		xdif = localx - peerx;
		ydif = localy - peery;
		rotation = atan(ydif/xdif) * 57.29578 - 90;
	}
	else if(peerx <= localx && peery < localy) // Sec 3 South-East of our position
	{
 		xdif = peerx - localx;
		ydif = localy - peery;
		rotation = atan(xdif/ydif) * 57.29578 - 180;
	}
	else if(peerx < localx && peery >= localy) // Sec 4 North-East of our position
	{
 		xdif = peerx - localx;
		ydif = peery - localy;
		rotation = atan(ydif/xdif) * 57.29578 - 270;
	}
	if(rotation < 0)
		rotation = rotation + 360;
	if(rotation >= 360)
		rotation = rotation - 360;
	return rotation;
}
//==========================================================================
// Purpose: returns 1 if emulator is detected, and set emulator memory locations
// Changes Globals: emuhandle, emuoffset
//==========================================================================
int EmulatorDetected()
{
	emuhandle = NULL;
	HANDLE processes; // will store a snapshot of all processes
	PROCESSENTRY32 pe32; // stores basic info of a process, using this one to read the ProcessID from
	processes = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); // make process snapshot
	pe32.dwSize = sizeof(PROCESSENTRY32); // correct size
	Process32First(processes, &pe32); // read info about the first process into pe32
	do // loop to find emulator
	{
		if(strcmp(pe32.szExeFile, "1964.exe") == 0 && !DEBUG_19641 || strcmp(pe32.szExeFile, "19641.exe") == 0 && DEBUG_19641 || strcmp(pe32.szExeFile, "1964_ultrafast.exe") == 0) // if 1964 0.8.5/1964 1.1 Ultrafast was found
		{
			emuhandle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			emuoffset = 0x20000000; // emulator offset is used for injecting into the ROM memory area in the emu
			break;
		}
		if(strcmp(pe32.szExeFile, "mupen64pp.exe") == 0) // if mupen64++ beta 0.1.3.12 was found
		{
			emuhandle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			emuoffset = 0x008DFC60;
			break;
		}
		if(strcmp(pe32.szExeFile, "mupen64plus-ui-console.exe") == 0) // if mupen64+ 1.99.5 was found
		{
			emuhandle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			emuoffset = 0x101FC6D0;
			break;
		}
		if(strcmp(pe32.szExeFile, "Project64.exe") == 0) // if Project64 1.6 was found
		{
			int versioncheck;
			emuhandle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			ReadProcessMemory(emuhandle, (LPVOID)0x0046AB90, &versioncheck, sizeof(versioncheck), NULL);
			if(versioncheck == 1785688656) // if version is PJ64 1.6
				ReadProcessMemory(emuhandle, (LPVOID)0x004D6A3C, &emuoffset, sizeof(emuoffset), NULL); // look up rom memory offset in PJ64 1.6
			else // unsupported PJ64 version, emulator not found
				emuhandle = NULL;
			break;
		}
	}
	while(Process32Next(processes, &pe32)); // loop continued until Process32Next deliver NULL or its interrupted with the "break" above
	CloseHandle(processes);
	if(!emuhandle) // if emulator was not found
		PrintError("Emulator not detected", 0);
	return emuhandle ? 1 : 0;
}
//==========================================================================
// Purpose: adds values to global structs PD/GE, this is so accessing mapname, base addresses array and such is easier to read (I'm a horrible programmer)
// Changes Globals: GE structs
//==========================================================================
void InitAddressTables()
{
	// OFFSET ADDRESSES BELOW (REQUIRES BASE ADDRESS TO USE)
	GE.mp_crouchheight = 0x000D3000 - 0x000D2FFC; // player's crouch height
	GE.mp_deathflag = 0x000D3038 - 0x000D2FFC; // player's deathflag
	GE.mp_invulnerable = 0x000A7454 - 0x000A73FC; // player's invulnerability timer
	GE.mp_health = 0x000D303C - 0x000D2FFC; // player's health
	GE.mp_shield = 0x000D3040 - 0x000D2FFC; // player's shield
	GE.mp_hudhealth = 0x000A744C - 0x000A73FC; // health for hud
	GE.mp_hudshield = 0x000A7450 - 0x000A73FC; // shield for hud
	GE.mp_showhud = 0x000A9D60 - 0x000A73FC; // show hud
	GE.mp_camx = 0x000D30A8 - 0x000D2FFC; // camera X rotation
	GE.mp_camy = 0x000D30B8 - 0x000D2FFC; // camera Y rotation
	GE.mp_crosshairx = 0x000D3F50 - 0x000D2FFC; // crosshair X position
	GE.mp_crosshairy = 0x000D3F54 - 0x000D2FFC; // crosshair y position
	GE.mp_xpos = 0x000D33EC - 0x000D2FFC; // player X position
	GE.mp_ypos = 0x000D2FD0 - 0x000D2FFC; // player Y position
	GE.mp_zpos = 0x000D33F4 - 0x000D2FFC; // player Z position
	GE.mp_weaponammo = 0x000D37FC - 0x000D2FFC; // weapon ammo
	GE.mp_weaponmodel = 0x000D380C - 0x000D2FFC; // weapon model
	GE.mp_weaponfunction = 0x000D37D0 - 0x000D2FFC; // current weapon function
	GE.mp_inventory = 0x000A8544 - 0x000A73FC; // player inventory aray offset
	GE.mp_totalammo[0] = 0x000D4094 - 0x000D2FFC; // pistol ammo
	GE.mp_totalammo[1] = 0x000D409C - 0x000D2FFC; // kf7 ammo
	GE.mp_totalammo[2] = 0x000D40BC - 0x000D2FFC; // g.launch ammo
	GE.mp_totalammo[3] = 0x000D40A8 - 0x000D2FFC; // r.launch ammo
	GE.mp_totalammo[4] = 0x000D40A0 - 0x000D2FFC; // shotgun ammo
	GE.mp_totalammo[5] = 0x000D40C0 - 0x000D2FFC; // magnum ammo
	GE.mp_totalammo[6] = 0x000D40C4 - 0x000D2FFC; // golden gun ammo
	GE.mp_totalammo[7] = 0x000D4100 - 0x000D2FFC; // tank ammo
	GE.mp_portalid = 0x000D33E8 - 0x000D2FFC; // player's current portal
	GE.mp_startrespawn = 0x000A7740 - 0x000A73FC; // press start fade
	GE.mp_startmenupage = 0x000A9D28 - 0x000A73FC; // multiplayer pause menu page id (7 = no screen, 6 = quit selection)
	GE.mp_start = 0x000A9D24 - 0x000A73FC; // start menu flag
	GE.mp_rgba[0] = 0x000A7730 - 0x000A73FC; // red for player screen (0 - 255)
	GE.mp_rgba[1] = 0x000A7734 - 0x000A73FC; // green for player screen (0 - 255)
	GE.mp_rgba[2] = 0x000A7738 - 0x000A73FC; // blue for player screen (0 - 255)
	GE.mp_rgba[3] = 0x000A773C - 0x000A73FC; // alpha for player screen (0.0f - 1.0f)
	GE.mp_pushx = 0x000A74E0 - 0x000A73FC; // hurt push X
	GE.mp_pushy = 0x000A74E8 - 0x000A73FC; // hurt push Y
	// STATIC ADDRESSES BELOW
	GE.controllersconnected = 0x000268D0; // controllers connected to N64
	GE.controller[0] = 0x00067CA4; // controller address array (P1)
	GE.controller[1] = 0x00067CAC; // controller address array (P2)
	GE.m_freeze[0] = 0x0002B544; // menu item lock address array [Level]
	GE.m_freeze[1] = 0x0002B548; // menu item lock address array [Game Length]
	GE.m_freeze[2] = 0x0002B550; // menu item lock address array [Weapon]
	GE.m_freeze[3] = 0x0002B54C; // menu item lock address array [Character]
	GE.m_freeze[4] = 0x0002B554; // menu item lock address array [Health]
	GE.m_freeze[5] = 0x0002B558; // menu item lock address array [Control Style]
	GE.m_freeze[6] = 0x0002B55C; // menu item lock address array [Aim]
	GE.camera = 0x00036494; // camera flag (0 = multiplayer, 1 = map overview, 2 = start flyby, 3 = in flyby, 4 = player in control, 5 = trigger restart map)
	GE.exit = 0x000364B0; // exit flag (0 = disable controls, 1 = enable controls)
	GE.pause[0] = 0x00048370; // pause flag (1 = GE is paused)
	GE.pause[1] = 0x0008C718; // pause flag (1 = GE is paused)
	GE.rng = 0x00024464; // random number generator (0 = disable, 1 = restart)
	GE.time = 0x00048394; // time clock (60 Hz)
	GE.musictrack = 0x00024334; // music track address
	GE.clock = 0x00030AF0; // clock address (float value, 60 Hz)
	GE.showclock = 0x00030AE8; // show countdown clock (0 = enable)
	GE.m_lock[0] = 0x00069740; // player 1 lock for character/health/control style
	GE.m_lock[1] = 0x00069744; // player 2 lock for character/health/control style
	GE.m_page = 0x0002A8C0; // menu page id
	GE.m_start[0] = 0x0002A8D0; // start flag (1 = start match)
	GE.m_start[1] = 0x0002A8F0; // start flag 2 (1 = start match)
	GE.m_crosshairx = 0x0002A908; // crosshair menu cursor X axis
	GE.m_crosshairy = 0x0002A90C; // crosshair menu cursor Y axis
	GE.m_characterscroll[0] = 0x00069710; // P1 character scroll
	GE.m_characterscroll[1] = 0x00069714; // P2 character scroll
	GE.m_players = 0x0002B520; // # of players
	GE.m_scenario = 0x0002B540; // menu scenario
	GE.m_level = 0x0002B534; // menu level
	GE.m_gamelength = 0x0002B538; // game length
	GE.m_weaponset = 0x00049160; // game weapon set
	GE.m_character[0] = 0x0002B524; // P1 character
	GE.m_character[1] = 0x0002B528; // P2 character
	GE.m_selectablecharacters = 0x0002B194; // total characters you're allowed to select (all = 64)
	GE.m_health[0] = 0x000697A8; // P1 health
	GE.m_health[1] = 0x000697AC; // P2 health
	GE.m_controlstyle[0] = 0x000697B8; // P1 control style
	GE.m_controlstyle[1] = 0x000697BC; // P2 control style
	GE.m_aim[0] = 0x00079F58; // P1 aim
	GE.m_aim[1] = 0x00079FC8; // P2 aim
	GE.m_aim[2] = 0x0002B53C; // aim text
	GE.m_title[0] = 0x002AD8CC; // multiplayer title text
	GE.m_title[1] = 0x002AD59C; // multiplayer title text
	GE.m_title[2] = 0x002AD8D0; // multiplayer title text
	GE.m_title[3] = 0x002AD8D5; // multiplayer title text
	GE.m_title[4] = 0x002AD8D8; // multiplayer title text
	GE.m_title[5] = 0x002AD8DD; // multiplayer title text
	GE.m_cheats[0] = 0x000696A0; // cheat menu [inv + all guns]
	GE.m_cheats[1] = 0x000696A8; // cheat menu [invis + inf ammo]
	GE.m_cheats[2] = 0x000696AC; // cheat menu [DK + tiny + paintball]
	GE.m_cheats[3] = 0x000696B0; // cheat menu [magnum + laser + gold gun]
	GE.m_cheats[4] = 0x000696B4; // cheat menu [silver pp7 + gold pp7 + no radar]
	GE.m_cheats[5] = 0x000696B8; // cheat menu [turbo + fast ani + slow ani]
	GE.m_cheats[6] = 0x000696BC; // cheat menu [enemy rockets + rocket l + grenade l + RC-P90]
	GE.m_cheats[7] = 0x000696C0; // cheat menu [throwing + hunting + laser]
	GE.m_cheats[8] = 0x0002A900; // cheat flag 1
	GE.m_cheats[9] = 0x0002A904; // cheat flag 2
	GE.mp_matchended = 0x0008C704; // used to see if multiplayer match has finished
	GE.mp_scorekill[0] = 0x00079F18; // P1 kill score
	GE.mp_scorekill[1] = 0x00079F84; // P2 kill score
	GE.mp_scoredeath[0] = 0x000A9D38; // P1 score death
	GE.mp_scoredeath[1] = 0x000AC7B8; // P2 score death
	GE.mp_scoresuicide[0] = 0x00079F14; // P1 score suicide
	GE.mp_scoresuicide[1] = 0x00079F88; // P2 score suicide
	GE.mp_freeze = 0x0008C700; // multiplayer freeze flag (used for score based game lengths)
}
//==========================================================================
// Purpose: read interger from memory, then return memory value
// Parameter: address location plus offset (offset is ignored when set to 0)
//==========================================================================
int ReadMemoryInt(const int addr, const int offset)
{
	int output; // temp var used for output of function
	ReadProcessMemory(emuhandle, (LPVOID)(addr + emuoffset + offset), &output, sizeof(output), NULL);
	return output;
}
//==========================================================================
// Purpose: read float from memory, then return memory value
// Parameter: address location plus offset (offset is ignored when set to 0)
//==========================================================================
float ReadMemoryFloat(const int addr, const int offset)
{
	float output; // temp var used for output of function
	ReadProcessMemory(emuhandle, (LPVOID)(addr + emuoffset + offset), &output, sizeof(output), NULL);
	return output;
}
//==========================================================================
// Purpose: write int to memory location
// Parameter: address location, value and offset (offset is ignored when set to 0)
//==========================================================================
void WriteMemoryInt(const int addr, const int value, const int offset)
{
	WriteProcessMemory(emuhandle, (LPVOID)(addr + emuoffset + offset), &value, sizeof(value), NULL);
}
//==========================================================================
// Purpose: write float to memory location
// Parameter: address location, value and offset (offset is ignored when set to 0)
//==========================================================================
void WriteMemoryFloat(const int addr, const float value, const int offset)
{
	WriteProcessMemory(emuhandle, (LPVOID)(addr + emuoffset + offset), &value, sizeof(value), NULL);
}
//==========================================================================
// Purpose: prints a nice exit message
//==========================================================================
void PrintError(const char *exitmsg, const int exitflag)
{
	ClearScreen();
	printf("\n %s%s\n\n   %s. Closing...\n", TITLE, LINE, exitmsg);
	if(exitflag)
		exit(EXIT_FAILURE);
}
//==========================================================================
// Purpose: clean up before closing program
// Changes Globals: closethread
//==========================================================================
void CleanUp()
{
	closethread = 1;
	pthread_join(manthread, NULL); // delete thread
	enet_deinitialize();
	CloseHandle(emuhandle); // close the handle
	Sleep(2000); // wait 2 seconds before closing prog
}
//==========================================================================
// Purpose: clear screen without using system("cls")
//==========================================================================
void ClearScreen()
{
	DWORD n; // number of characters written
	DWORD size; // number of visible characters
	COORD coord = {0}; // top left screen position
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	HANDLE h = GetStdHandle(STD_OUTPUT_HANDLE); // get a handle to the console
	GetConsoleScreenBufferInfo(h, &csbi);
	size = csbi.dwSize.X * csbi.dwSize.Y; // find the number of characters to overwrite
	FillConsoleOutputCharacter(h, TEXT(' '), size, coord, &n); // overwrite the screen buffer with whitespace
	GetConsoleScreenBufferInfo(h, &csbi);
	FillConsoleOutputAttribute(h, csbi.wAttributes, size, coord, &n);
	SetConsoleCursorPosition(h, coord); // reset the cursor to the top left position
}