//==========================================================================
// Mouse Injector for GoldenEye 007/Perfect Dark
//==========================================================================
// Copyright (c) 2014, stolen + carnivorous's fixes
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the <organization> nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL STOLEN BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//==========================================================================
// TODO: find a consistent method of detecting camspy and slayer addresses
//==========================================================================
#include <stdio.h>
#include <windows.h>
#include <conio.h>
#include <tlhelp32.h>
#include "main.h"

int main()
{
	SetConsoleTitle("Mouse Injector");
	int emualive = EmulatorDetected();
	if(emualive) // if emulator is detected
	{
		LoadSettings(); // load user settings from mouseinjector.ini
		Interface(); // render interface for the first time
		TimerInit(); // setup the timer (used for GE crosshair scroll)
		atexit(SaveSettings); // save when program exits
		int limitpolling = 0; // used for limiting emu check, pd hack & debug interface
		while(emualive) // loop only if the emulator is detected
		{
			Input();
			DetectMap();
			if(CFG.mousetoggle && currentgame != PLAYINGUNKNOWN)
				Inject();
			limitpolling++;
			if(limitpolling % 3 == 0)
			{
				if(currentgame == PLAYINGPERFECTDARK)
					PDSpeedHack();
				if(CFG.debug)
					Interface();
			}
			if(limitpolling % 200 == 0)
			{
				emualive = EmulatorDetected();
				limitpolling = 0;
			}
			Sleep(tickrate);
		}
	}
	else // if emulator is not found
	{
		printf("\n %s%s\n\n   Emulator not detected. Closing...", TITLE, LINE);
		Sleep(2000); // wait 2 seconds before closing program
	}
	CloseHandle(emuhandle); // close the handle
	return 0;
}
//==========================================================================
// Purpose: checks user input and changes program settings based upon user input
// Changes Globals: CFG.mousetoggle, mouselock.x, mouselock.y, CFG.selectedoption, CFG.invertpitch, CFG.geaimmode, CFG.debug, CFG.showsettings, CFG.sensitivity, CFG.crosshair
//==========================================================================
void Input()
{
	int updateinterface = 0, updatequick = 0;
	if(K_4) // mouse toggle (4)
	{
		CFG.mousetoggle = !CFG.mousetoggle;
		GetCursorPos(&mouselock);
		if(mouselock.x > GetSystemMetrics(SM_CXSCREEN) - 70 || mouselock.x < 70 || mouselock.y > GetSystemMetrics(SM_CYSCREEN) - 70 || mouselock.y < 70) // if mouse toggle was enabled on the edge of the screen (within 70px), set lock to the center of the screen (this will remove the possibility of the cursor getting stuck when it is too close to the boarder of the screen)
			mouselock.x = GetSystemMetrics(SM_CXSCREEN) / 2, mouselock.y = GetSystemMetrics(SM_CYSCREEN) / 2;
		updateinterface = 1;
	}
	if(K_5 && CFG.showsettings && !updateinterface && CFG.selectedoption != EDITINGSENSITIVITY) // mouse sensitivity (5)
		CFG.selectedoption = EDITINGSENSITIVITY, updateinterface = 1;
	if(K_6 && CFG.showsettings && !updateinterface && CFG.selectedoption != EDITINGCROSSHAIR) // crosshair sensitivity (6)
		CFG.selectedoption = EDITINGCROSSHAIR, updateinterface = 1;
	if(K_7 && CFG.showsettings && !updateinterface) // invert pitch toggle (7)
		CFG.invertpitch = !CFG.invertpitch, updateinterface = 1;
	if(K_8 && CFG.showsettings && !updateinterface && fastemu && currentgame == PLAYINGGOLDENEYE) // goldeneye aim mode toggle (8)
		CFG.geaimmode = !CFG.geaimmode, updateinterface = 1;
	if(K_9 && CFG.showsettings && !updateinterface) // debug toggle (9)
		CFG.debug = !CFG.debug, updateinterface = 1;
	if((K_CTRL && K_0 || K_0 && K_CTRL) && !CFG.debug && !updateinterface) // hide/show settings (CTRL+0)
		CFG.showsettings = !CFG.showsettings, updateinterface = 1;
	if(K_PLUS && CFG.showsettings && !updateinterface) // numpad plus (+)
	{
		if(CFG.selectedoption == EDITINGSENSITIVITY && CFG.sensitivity > 0 && CFG.sensitivity < 80)
			CFG.sensitivity++, updateinterface = 1;
		if(CFG.selectedoption == EDITINGCROSSHAIR && CFG.crosshair >= 0 && CFG.crosshair < 18)
			CFG.crosshair++, updateinterface = 1;
		updatequick = 1;
	}
	if(K_MINUS && CFG.showsettings && !updateinterface) // numpad minus (-)
	{
		if(CFG.selectedoption == EDITINGSENSITIVITY && CFG.sensitivity > 1 && CFG.sensitivity < 81)
			CFG.sensitivity--, updateinterface = 1;
		if(CFG.selectedoption == EDITINGCROSSHAIR && CFG.crosshair >= 1 && CFG.crosshair < 19)
			CFG.crosshair--, updateinterface = 1;
		updatequick = 1;
	}
	if((K_CTRL && K_F9 || K_F9 && K_CTRL) && currentgame != PLAYINGUNKNOWN) // hard mode preset for GE & PD (CTRL+F9)
	{
		if(currentgame == PLAYINGGOLDENEYE) // GE
		{
			WriteMemoryFloat(0x0002A9A4, 0.75, 0); // 75% [health]
			WriteMemoryFloat(0x0002A9A8, 3, 0); // 300% [damage]
			WriteMemoryFloat(0x0002A9AC, 6, 0); // 60% [accuracy]
			WriteMemoryFloat(0x0002A9A0, 1, 0); // 100% [reaction] (anything over 100% crashes some maps)
			WriteMemoryFloat(0x00040A90, 0, 0); // off [auto-aim]
			WriteMemoryFloat(0x00040AA8, 0, 0); // off [sight on-screen]
			WriteMemoryFloat(0x00040AC0, 0, 0); // off [ammo on-screen]
		}
		else // PD
		{
			WriteMemoryFloat(0x0009DFF4, 0.80, 0); // 80% [health]
			WriteMemoryFloat(0x0009DFF8, 1.65, 0); // 165% [damage]
			WriteMemoryFloat(0x0009DFFC, 3.5, 0); // 350% [accuracy]
			WriteMemoryInt(0x0009DFEC, 0x00708DAD, 0); // UI slider positions for health, damage and accuracy
		}
		Sleep(200); // don't repeat this too quickly, halt the program for 200 ms
	}
	if(updateinterface)
	{
		Interface();
		Sleep(100);
		if(!updatequick)
			Sleep(100);
	}
}
//==========================================================================
// Purpose: handles all of the screen information
//==========================================================================
void Interface()
{
	ClearScreen();
	if(CFG.debug)
		DebugInterface();
	else
	{
		printf("\n %s%s\n\n   Main Menu - Press [#] to Use Menu\n\n\n", TITLE, LINE); // title
		printf(CFG.mousetoggle ? "   [4] - [ON] Mouse Injection" : "   [4] - [OFF] Mouse Injection");
		if(CFG.showsettings)
		{
			printf("\n\n   [5] - Mouse Sensitivity: %d%%", CFG.sensitivity * 5);
			printf(CFG.selectedoption == EDITINGSENSITIVITY ? " [+/-]\n\n" : "\n\n");
			printf("   [6] - Crosshair Movement: ");
			printf(CFG.crosshair ? "%d%%" : "Disabled", CFG.crosshair * 100 / 6);
			printf(CFG.selectedoption == EDITINGCROSSHAIR ? " [+/-]\n\n" : "\n\n");
			printf(CFG.invertpitch ? "   [7] - [ON] Invert Pitch\n\n" : "   [7] - [OFF] Invert Pitch\n\n");
			printf(fastemu && currentgame == PLAYINGGOLDENEYE ? (CFG.geaimmode ? "   [8] - [ON] Virtua Cop Aiming (GE Only)" : "   [8] - [OFF] Virtua Cop Aiming (GE Only)") : ""); // non-fastemu build and perfect dark do not support aim mode (see Inject() faq)
#ifdef DEBUGMODE
			printf("\n\n\n   [9] - Debug Mode\n\n");
#else
			printf("\n\n\n\n\n");
#endif
		}
		else
			printf("\n\n\n\n\n\n\n\n\n\n\n\n\n");
		printf(CFG.showsettings ? "   [CTRL+0] - Hide Settings" : "   [CTRL+0] - Show Settings");
		printf("\n\n Note: [+/-] to Change Values\n%s\n", LINE);
	}
}
//==========================================================================
// Purpose: loads settings stored in mouseinjector.ini
// Changes Globals: CFG.sensitivity, CFG.crosshair, CFG.invertpitch, CFG.debug, CFG.showsettings, CFG.selectedoption, CFG.crouchkey
//==========================================================================
void LoadSettings()
{
	FILE *fileptr; // create a file pointer and open mouseinjector.ini from same dir as our program
	if((fileptr = fopen("mouseinjector.ini", "r")) != NULL) // if the INI exists
	{
		char line[128][128]; // char array used for file to write to
		char lines[128]; // maximum lines read size
		int counter = 0; // used to assign each line to a array
		while(fgets(lines, sizeof(lines), fileptr) != NULL && counter < 9) // read the first 8 lines
		{
			strcpy(line[counter], lines); // read file lines and assign value to line array
			counter++; // add 1 to counter, so the next line can be read
		}
		fclose(fileptr); // close the file stream
		if(atol(line[0]) >= 1 && atol(line[0]) <= 80 && atol(line[1]) >= 0 && atol(line[1]) <= 18 && (atol(line[2]) == 0 || atol(line[2]) == 1) && (atol(line[3]) == 0 || atol(line[3]) == 1) && (atol(line[4]) == 0 || atol(line[4]) == 1) && (atol(line[5]) == 0 || atol(line[5]) == 1) && atol(line[6]) >= EDITINGSENSITIVITY && atol(line[6]) <= EDITINGCROSSHAIR && counter == 8) // check mouseinjector.ini values to see if they are valid and safe to load
		{
			CFG.sensitivity = atol(line[0]);
			CFG.crosshair = atol(line[1]);
			CFG.invertpitch = atol(line[2]);
			CFG.geaimmode = atol(line[3]);
			CFG.debug = atol(line[4]);
			CFG.showsettings = atol(line[5]);
			CFG.selectedoption = atol(line[6]);
			CFG.crouchkey = atol(line[7]);
#ifdef DEBUGMODE
			if(CFG.debug && !CFG.showsettings) // if debug mode is on and settings are locked (aka hidden), debug mode cannot be turned off. To avoid this, disable debug mode if showsettings is off
#endif
			CFG.debug = 0; // always disable debug mode in the release build
		}
		else
		{
			MessageBox(HWND_DESKTOP, "Loading mouseinjector.ini failed!\n\nUnknown values detected, loading default settings.", "Error", MB_ICONERROR | MB_OK); // tell the user loading mouseinjector.ini failed
			SaveSettings(); // overwrite mouseinjector.ini with valid settings
		}
	}
	else // if loading file failed
	{
		MessageBox(HWND_DESKTOP, "Loading mouseinjector.ini failed!\n\nAttempting to create mouseinjector.ini file.", "Error", MB_ICONERROR | MB_OK); // tell the user loading mouseinjector.ini failed
		SaveSettings(); // create mouseinjector.ini
	}
}
//==========================================================================
// Purpose: saves current settings to mouseinjector.ini
//==========================================================================
void SaveSettings()
{
	FILE *fileptr; // create a file pointer and open mouseinjector.ini from same dir as our program
	if((fileptr = fopen("mouseinjector.ini", "w")) != NULL) // if the INI exists
	{
		fprintf(fileptr, "%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d", CFG.sensitivity, CFG.crosshair, CFG.invertpitch, CFG.geaimmode, CFG.debug, CFG.showsettings, CFG.selectedoption, CFG.crouchkey); // write current settings to mouseinjector.ini
		fclose(fileptr); // close the file stream
	}
	else // if saving file failed
		MessageBox(HWND_DESKTOP, "Saving mouseinjector.ini failed!", "Error", MB_ICONERROR | MB_OK); // tell the user saving mouseinjector.ini failed
}
//==========================================================================
// Purpose: call MouseMovement function and inject mouse x and y into current game
// Q: Could you explain this line? bypassaimmode || !aimingflag ? xrot / 10.0f * (CFG.sensitivity / 40.0f) : aimx
// A: The above line is used to calculate X axis camera rotation (camx). For this example lets assume you are playing the original GoldenEye rom with fastemu and CFG.geaimmode on. If the player is not in aim mode, regular mouselook will be calculated from the first part of the line. However if the player is aiming (aimingflag = 1), then mouselook will be disabled. This is designed so when the player is aiming with the crosshair, the view will be locked (like if you were aiming with the N64 controller). However if the crosshair moves near the edge of the screen, then aimx is set to a value calculated by the GEAimMode function. The X axis camera rotation then uses aimx as input, which will make the screen scroll to whatever side the crosshair is touching. But, if bypassaimmode is true then everything related with aiming mode is bypassed and the first part of the argument will always be used (aka always mouselook)
// Q: What does this line mean? bypassaimmode = CFG.geaimmode && fastemu ? (ReadMemoryInt(GE.customweaponflag, 0) != 0x756E6172 ? 1 : 0) : 1;
// A: bypassaimmode will be set to true if CFG.geaimmode is turned off, or fastemu flag is not present, or GE rom has custom weapons. bypassaimmode is then used as a flag to bypass aiming mode (aka always mouselook)
// Q: Why is aiming mode disabled for non-overclocked emulators?
// A: If the emulator is not overclocked the crosshair cannot be locked perfectly. The result will look 'twitchy' and you will see some visible injection artifacts with the crosshair. It's better to just disable aiming mode altogether for non-overclocked emulators
// Q: Why is aiming mode disabled for ROM hacks with custom weapons?
// A: Custom weapons would most likely mean the gun rotation table in GEAimMode() will no longer be accurate. This would result in weapon models not lining up to the crosshair. So to avoid this we check to see if the first weapon's title address has been moved. If this is true then we ignore the aiming flag. This also applies for the lines: if(bypassaimmode || GEAimMode(aimingflag, fov)) and if(CFG.crosshair && (bypassaimmode || !aimingflag))
// Q: Could you explain !aimingflag ? 10.0f : 40.0f
// A: While the player is aiming weapon sway will be reduced by 75%. While this is not in the original design of GE/PD I feel it gives a legitimate advantage for aiming instead of only making the crosshair visible
//==========================================================================
void Inject()
{
	MouseMovement(); // update xrot and yrot vars so injection use latest mouse input
	if(currentgame == PLAYINGGOLDENEYE)
	{
		const int camera = ReadMemoryInt(GE.camera, 0), death = ReadMemoryInt(playerbase, GE.deathflag), watch = ReadMemoryInt(playerbase, GE.watch), exit = ReadMemoryInt(GE.exit, 0), pause = ReadMemoryInt(GE.pause, 0), aimingflag = ReadMemoryInt(playerbase, GE.aimingflag), menupage = ReadMemoryInt(GE.menupage, 0), tankflag = ReadMemoryInt(GE.tankflag, 0), mproundend = ReadMemoryInt(GE.matchended, 0), mppausemenu = ReadMemoryInt(playerbase, GE.multipausemenu), bypassaimmode = CFG.geaimmode && fastemu ? (ReadMemoryInt(GE.customweaponflag, 0) != 0x756E6172 ? 1 : 0) : 1;
		const float fov = ReadMemoryFloat(playerbase, GE.fov), gunsensitivity = (CFG.sensitivity / 40.0f) * (CFG.crosshair / 2.5f);
		float camx = ReadMemoryFloat(playerbase, GE.camx), camy = ReadMemoryFloat(playerbase, GE.camy);
		if(camx >= 0 && camx <= 360 && camy >= -90 && camy <= 90 && fov >= 7 && fov <= 60 && death == 0 && watch == 0 && pause == 0 && (camera == 4 || camera == 0) && exit == 1 && menupage == 11 && !mproundend && !mppausemenu) // if safe to inject
		{
			if(!tankflag) // only allow crouching if player is not in tank
				Crouch();
			if(bypassaimmode || GEAimMode(aimingflag, fov)) // allow mouselook if the player isn't aiming or if the crosshair wants to scroll, but if bypassaimmode is true then always mouselook (see FAQ)
			{
				if(!tankflag) // player is on foot
				{
					camx += (bypassaimmode || !aimingflag ? xrot / 10.0f * (CFG.sensitivity / 40.0f) : aimx) * (fov / 60);
					if(camx < 0)
						camx += 360;
					if(camx >= 360)
						camx -= 360;
					WriteMemoryFloat(playerbase, camx, GE.camx);
				}
				else // player is in tank
				{
					float tankx = ReadMemoryFloat(GE.tankxrot, 0) + (bypassaimmode || !aimingflag ? xrot / 10.0f * (CFG.sensitivity / 40.0f) : aimx) / (360 / TANKXROTATIONLIMIT * 2.5) * (fov / 60);
					if(tankx < 0)
						tankx += TANKXROTATIONLIMIT;
					if(tankx >= TANKXROTATIONLIMIT)
						tankx -= TANKXROTATIONLIMIT;
					WriteMemoryFloat(GE.tankxrot, tankx, 0);
				}
				camy += (bypassaimmode || !aimingflag ? (CFG.invertpitch ? -yrot : yrot) / -10.0f * (CFG.sensitivity / 40.0f) : -aimy) * (fov / 60);
				if(camy < -20 && tankflag) // tank limits player from looking down -20
					camy = -20;
				if(camy < -90)
					camy = -90;
				if(camy > 90)
					camy = 90;
				WriteMemoryFloat(playerbase, camy, GE.camy);
				if(CFG.crosshair && (bypassaimmode || !aimingflag)) // if crosshair movement is enabled (do not bother calculating weapon movement while the player is in aim mode, unless bypassaimmode is true)
				{
					if(!tankflag)
					{
						float gunx = ReadMemoryFloat(playerbase, GE.gunx), crosshairx = ReadMemoryFloat(playerbase, GE.crosshairx); // after camera x and y have been calculated and injected, calculate the gun/crosshair movement
						gunx += xrot / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 60) * 0.019f;
						crosshairx += xrot / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 4 / 15) * 0.01912f;
						if(gunx < -GEGUNAIMLIMIT)
							gunx = -GEGUNAIMLIMIT;
						if(gunx > GEGUNAIMLIMIT)
							gunx = GEGUNAIMLIMIT;
						if(crosshairx < -GECROSSHAIRLIMIT)
							crosshairx = -GECROSSHAIRLIMIT;
						if(crosshairx > GECROSSHAIRLIMIT)
							crosshairx = GECROSSHAIRLIMIT;
						WriteMemoryFloat(playerbase, gunx, GE.gunx);
						WriteMemoryFloat(playerbase, crosshairx, GE.crosshairx);
					}
					if((!tankflag && camy > -90 || tankflag && camy > -20) && camy < 90) // only allow player's gun to pitch within a valid range
					{
						float guny = ReadMemoryFloat(playerbase, GE.guny), crosshairy = ReadMemoryFloat(playerbase, GE.crosshairy);
						guny += (CFG.invertpitch ? -yrot : yrot) / (!aimingflag ? 40.0f : 20.0f) * gunsensitivity * (fov / 60) * 0.025f;
						crosshairy += (CFG.invertpitch ? -yrot : yrot) / (!aimingflag ? 40.0f : 20.0f) * gunsensitivity * (fov / 4 / 15) * 0.0225f;
						if(guny < -GEGUNAIMLIMIT)
							guny = -GEGUNAIMLIMIT;
						if(guny > GEGUNAIMLIMIT)
							guny = GEGUNAIMLIMIT;
						if(crosshairy < -GECROSSHAIRLIMIT)
							crosshairy = -GECROSSHAIRLIMIT;
						if(crosshairy > GECROSSHAIRLIMIT)
							crosshairy = GECROSSHAIRLIMIT;
						WriteMemoryFloat(playerbase, guny, GE.guny);
						WriteMemoryFloat(playerbase, crosshairy, GE.crosshairy);
					}
				}
			}
		}
		else if(menupage != 11 && menupage != 23) // if user is in menu
		{
			float menucrosshairx = ReadMemoryFloat(GE.menux, 0), menucrosshairy = ReadMemoryFloat(GE.menuy, 0);
			menucrosshairx += xrot / 10.0f * (CFG.sensitivity / 40.0f) * 6;
			menucrosshairy -= yrot / -10.0f * (CFG.sensitivity / 40.0f) * (400.0f / 290.0f * 6); // y is a little weaker then x in the menu so add more power to make it feel even with x axis
			if(menucrosshairx < 20)
				menucrosshairx = 20;
			if(menucrosshairx > 420)
				menucrosshairx = 420;
			if(menucrosshairy < 20)
				menucrosshairy = 20;
			if(menucrosshairy > 310)
				menucrosshairy = 310;
			WriteMemoryFloat(GE.menux, menucrosshairx, 0);
			WriteMemoryFloat(GE.menuy, menucrosshairy, 0);
		}
	}
	else // playing perfect dark
	{
		const int camera = ReadMemoryInt(PD.camera, 0), death = ReadMemoryInt(playerbase, PD.deathflag), menu = ReadMemoryInt(PD.menu, 0), pause = ReadMemoryInt(PD.pause, 0), aimingflag = ReadMemoryInt(playerbase, PD.aimingflag), grabflag = ReadMemoryInt(playerbase, PD.grabflag);
		const float fov = ReadMemoryFloat(playerbase, PD.fov), gunsensitivity = (CFG.sensitivity / 40.0f) * (CFG.crosshair / 2.5f);
		float camx = ReadMemoryFloat(playerbase, PD.camx), camy = ReadMemoryFloat(playerbase, PD.camy), bikex = ReadMemoryFloat(bikebase[0], 0), bikeroll = ReadMemoryFloat(bikebase[0], PD.bikeroll);
		if(camx >= 0 && camx <= 360 && camy >= -90 && camy <= 90 && fov >= 2 && fov <= 60 && death == 0 && menu == 1 && pause == 0 && camera == 1 && (grabflag == 0 || grabflag == 4 || grabflag == 3 && bikebase[0] && bikex <= BIKEXROTATIONLIMIT && bikex >= -BIKEXROTATIONLIMIT && bikeroll <= BIKEROLLLIMIT && bikeroll >= -BIKEROLLLIMIT)) // if safe to inject
		{
			if(grabflag != 3) // if player is on foot
			{
				camx += xrot / 10.0f * (CFG.sensitivity / 40.0f) * (fov / 60);
				if(camx < 0)
					camx += 360;
				if(camx >= 360)
					camx -= 360;
				WriteMemoryFloat(playerbase, camx, PD.camx);
				Crouch();
			}
			else // if player is riding hoverbike (and hoverbike address is valid)
			{
				bikex -= xrot / 10.0f * (CFG.sensitivity / 40.0f) / (360 / BIKEXROTATIONLIMIT) * (fov / 60);
				bikeroll += xrot / 10.0f * (CFG.sensitivity / 40.0f) * (fov / 60) / 100;
				if(bikex < 0)
					bikex += BIKEXROTATIONLIMIT;
				if(bikex >= BIKEXROTATIONLIMIT)
					bikex -= BIKEXROTATIONLIMIT;
				if(bikeroll < -BIKEROLLLIMIT)
					bikeroll = -BIKEROLLLIMIT;
				if(bikeroll > BIKEROLLLIMIT)
					bikeroll = BIKEROLLLIMIT;
				WriteMemoryFloat(bikebase[0], bikex, 0);
				WriteMemoryFloat(bikebase[0], bikeroll, PD.bikeroll);
			}
			camy += (CFG.invertpitch ? -yrot : yrot) / -10.0f * (CFG.sensitivity / 40.0f) * (fov / 60);
			if(camy < -90)
				camy = -90;
			if(camy > 90)
				camy = 90;
			WriteMemoryFloat(playerbase, camy, PD.camy);
			if(CFG.crosshair) // if crosshair movement is enabled
			{
				float gunx = ReadMemoryFloat(playerbase, PD.gunrx), crosshairx = ReadMemoryFloat(playerbase, PD.crosshairx); // after camera x and y have been calculated and injected, calculate the gun/crosshair movement
				gunx += xrot / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 60) * 0.05f;
				crosshairx += xrot / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 4 / 15) * 0.05f;
				if(gunx < -PDGUNAIMLIMIT)
					gunx = -PDGUNAIMLIMIT;
				if(gunx > PDGUNAIMLIMIT)
					gunx = PDGUNAIMLIMIT;
				if(crosshairx < -PDCROSSHAIRLIMIT)
					crosshairx = -PDCROSSHAIRLIMIT;
				if(crosshairx > PDCROSSHAIRLIMIT)
					crosshairx = PDCROSSHAIRLIMIT;
				WriteMemoryFloat(playerbase, gunx, PD.gunrx);
				WriteMemoryFloat(playerbase, gunx, PD.gunlx);
				WriteMemoryFloat(playerbase, crosshairx, PD.crosshairx);
				if(camy > -90 && camy < 90) // only allow player's gun to pitch within a valid range
				{
					float guny = ReadMemoryFloat(playerbase, PD.gunry), crosshairy = ReadMemoryFloat(playerbase, PD.crosshairy);
					guny += (CFG.invertpitch ? -yrot : yrot) / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 60) * 0.075f;
					crosshairy += (CFG.invertpitch ? -yrot : yrot) / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 4 / 15) * 0.1f;
					if(guny < -PDGUNAIMLIMIT)
						guny = -PDGUNAIMLIMIT;
					if(guny > PDGUNAIMLIMIT)
						guny = PDGUNAIMLIMIT;
					if(crosshairy < -PDCROSSHAIRLIMIT)
						crosshairy = -PDCROSSHAIRLIMIT;
					if(crosshairy > PDCROSSHAIRLIMIT)
						crosshairy = PDCROSSHAIRLIMIT;
					WriteMemoryFloat(playerbase, guny, PD.gunry);
					WriteMemoryFloat(playerbase, guny, PD.gunly);
					WriteMemoryFloat(playerbase, crosshairy, PD.crosshairy);
				}
			}
		}
	}
}
//==========================================================================
// Purpose: crouching function for GoldenEye/Perfect Dark (2 = stand, 0 = duck)
// Q: Can you explain about that first if else statement?
// A: When the player is holding down crouch while aiming, GE will force the player to stand as part of its auto stand design. The code below combats this by injecting the correct button combinations required to crouch and stand without any interference from auto stand. Read below for a more complex explanation.
//
// Pressing R will make the player stand and pressing R + c-down will make the player crouch. If the player is pressing CTRL while in aiming mode then the below code will inject c-down into the controller address, which will make the player crouch (this is to combat the auto stand design while pressing R). The only issue with this technique (besides from being hacky) is when the player has the sniper rifle equipped, c-up and c-down are instead used to control the zoom for the sniper rifle. This means the c-down injection method will make the sniper rifle zoom out instead of making the player crouch. The sniper rifle is the only weapon which does not require c-down to make the player crouch (playerbase = 0 works fine). A cheap way around this is to disable the c-down injection when the current weapon id matches the sniper rifle id (17). This fixes the problem but introduces a new one.
//
// ROM hacks with custom weapons will probably have another weapon for slot 17 (most likely not a sniper rifle). An example is the ROM hack GoldFinger 64 which has their version of the sniper rifle under a different weapon id. This means the method of comparing the current weapon id with the default sniper id will not work. To combat this the if else statement will only compare weapon ids if the first weapons's title is called "Unarmed". This is an effective method as the chances of a ROM hack with custom weapons will most likely have new weapon names which means the address for the title of the first weapon will have been moved. If true, the if else statement will use an alternative fail-safe for detecting if the player has the sniper equipped or not.
//
// If the player has the sniper equipped and the address for the title of the first weapon has not been moved, then it is assumed the emu is playing the original version of GoldenEye 007 which will cause the if else statement to fail and the below playerbase injection will make the player crouch instead of using the c-down injection (this works fine for snipers). If the emu is playing a ROM hack then the if else statement will use an alternative detection method. This alternative is unpolished but at least works. It first checks to see if the player is standing (playerbase == 2) and if so applies the c-down injection hack. If the player is ducking (playerbase =! 2) but the view is still above -99, then it will go ahead and apply the c-down hack. This will make the player crouch normally but if the player has the sniper rifle equipped then it will make the sniper unzoom until the player has fully ducked. This is a better alternative to the player standing.
//==========================================================================
void Crouch()
{
	if(GetAsyncKeyState(CFG.crouchkey) && currentgame == PLAYINGGOLDENEYE && ReadMemoryInt(playerbase, GE.aimingflag) && (ReadMemoryInt(playerbase, GE.currentweapon) != 17 && ReadMemoryInt(GE.customweaponflag, 0) == 0x756E6172 || (playerbase == 2 || ReadMemoryFloat(playerbase, GE.crouchheight) >= -99.5f) && ReadMemoryInt(GE.customweaponflag, 0) != 0x756E6172)) // player is holding down crouch and aiming so bind c-down to the controller address (see FAQ for more information)
	{
		const int controller = ReadMemoryInt(GE.controller, 0), controllercombos[9] = {0x00100000, 0x20100000, 0x40100000, 0x80100000, 0x60100000, 0xC0100000, 0xA0100000, 0xE0100000}; // aiming, firing, reloading, changing weapons, reloading and firing, reloading and changing weapons, firing and changing weapons, firing reloading and changing weapons
		for(int i = 0; i < 9; i++)
			for(int j = 0; j < 3; j++)
				if(controller == controllercombos[i] + j * 0x10000)
				{
					WriteMemoryInt(GE.controller, controllercombos[i] + j * 0x10000 + 0x40000, 0);
					return;
				}
	}
	if(!GetAsyncKeyState(CFG.crouchkey)) // user isn't holding down the crouch button
		WriteMemoryInt(playerbase, 2, 0); // force standing flag value (the side effect to this brute force method is it causes a speed glitch while crawling in tunnels in PD only)
	else // player is holding down crouch
		WriteMemoryInt(playerbase, 0, 0); // set in-game crouch flag to lowest point
}
//==========================================================================
// Purpose: replicate the original aiming system for GE, returns 1 if crosshair is near the screen border and requires the pov to scroll
// Changes Globals: crosshairposx, crosshairposy, aimx, aimy
//==========================================================================
int GEAimMode(const int aimingflag, const float fov)
{
	int enablemouselook = 1;
	const float crosshairx = ReadMemoryFloat(playerbase, GE.crosshairx), crosshairy = ReadMemoryFloat(playerbase, GE.crosshairy), offsetpos[2][33] = {{0, 0, 0, 0, 0.125, 0.125, 0.15, 0.5, 0.8, 0.4, 0.5, 0.5, 0.55, 0.9, 0.25, 0.625, 0.65, 0.85, 0.25, 0.15, 0.125, 0.125, 0.5, 1.3, 1, 1.05, 0, 0, 0, 0, 1.3, 1.7}, {0, 0, 0, 0, 0.1, 0.1, 0.2, 0.325, 1, 0.3, 0.425, 0.425, 0.525, 0.95, 0.1, 0.55, 0.9, 0.8, 0.25, 0.1, 0.1, 0.1, 0.275, 1.925, 1, 1.3, 0, 0, 0, 0, 0.8, 0.65}}; // table of X/Y offset for weapons
	const int currentweapon = ReadMemoryInt(playerbase, GE.currentweapon);
	if(aimingflag) // if player is aiming
	{
		enablemouselook = 0;
		TimeUpdate();
		crosshairposx += xrot / 10.0f * (CFG.sensitivity / 292.0f); // calculate the crosshair position
		crosshairposy += (CFG.invertpitch ? yrot : -yrot) / -10.0f * (CFG.sensitivity / 292.0f);
		if(crosshairposx < -GECROSSHAIRLIMIT) // apply limits then inject
			crosshairposx = -GECROSSHAIRLIMIT;
		if(crosshairposx > GECROSSHAIRLIMIT)
			crosshairposx = GECROSSHAIRLIMIT;
		if(crosshairposy < -GECROSSHAIRLIMIT)
			crosshairposy = -GECROSSHAIRLIMIT;
		if(crosshairposy > GECROSSHAIRLIMIT)
			crosshairposy = GECROSSHAIRLIMIT;
		WriteMemoryFloat(playerbase, crosshairposx, GE.crosshairx);
		WriteMemoryFloat(playerbase, crosshairposy, GE.crosshairy);
		WriteMemoryFloat(playerbase, crosshairposx * (1.11f + (currentweapon >= 0 && currentweapon <= 32 ? offsetpos[0][currentweapon] : 0.15f)) + (fov / 60) - 1, GE.gunx); // calculate and inject the gun angles (uses pre-made pos table or if unknown weapon use fail-safe value)
		WriteMemoryFloat(playerbase, crosshairposy * (1.11f + (currentweapon >= 0 && currentweapon <= 32 ? offsetpos[1][currentweapon] : 0)) + (fov / 60) - 1, GE.guny);
		if(crosshairx > 0 && crosshairx / GECROSSHAIRLIMIT > 0.9f) // if crosshair is within the last 90% of the border then calculate a linear scrolling speed and enable mouselook
			aimx = (crosshairx / GECROSSHAIRLIMIT - 0.9f) * 1500 * TIME.step, enablemouselook = 1;
		else if(crosshairx < 0 && crosshairx / GECROSSHAIRLIMIT < -0.9f)
			aimx = (crosshairx / GECROSSHAIRLIMIT + 0.9f) * 1500 * TIME.step, enablemouselook = 1;
		else
			aimx = 0;
		if(crosshairy > 0 && crosshairy / GECROSSHAIRLIMIT > 0.9f)
			aimy = (crosshairy / GECROSSHAIRLIMIT - 0.9f) * 1500 * TIME.step, enablemouselook = 1;
		else if(crosshairy < 0 && crosshairy / GECROSSHAIRLIMIT < -0.9f)
			aimy = (crosshairy / GECROSSHAIRLIMIT + 0.9f) * 1500 * TIME.step, enablemouselook = 1;
		else
			aimy = 0;
	}
	else // player is not aiming so reset crosshairposxy values
		crosshairposx = crosshairx, crosshairposy = crosshairy;
	return enablemouselook;
}
//==========================================================================
// Purpose: force PD to unlock fps
//==========================================================================
void PDSpeedHack()
{
	if(!fastemu) // this only works if we're using a fastemu
		return;
	if(ReadMemoryInt(PD.fpscounter, 0) == 0x8005EE68) // if PD is running under 60fps
	{
		for(int i = 0; i < 96; i++)
			WriteMemoryInt(PD.timer, 0x00000000, 0); // intentionally screw with the timing system
		WriteMemoryInt(PD.timer, 0x00010000, 0); // set clock address back to default (reset fps lock to 60)
	}
}
//==========================================================================
// Purpose: searches for the current map memory locations
// Changes Globals: playerbase, currentgame, bikebase
//==========================================================================
void DetectMap()
{
	int pointerdump[64];
	if(currentgame != Game()) // if game has been changed, reset playerbase and update currentgame
	{
		playerbase = 0;
		currentgame = Game();
		Interface();
	}
	if(currentgame == PLAYINGGOLDENEYE)
	{
		if(playerbase != BONDDATA && (ReadMemoryInt(GE.camera, 0) == 1 || ReadMemoryInt(GE.camera, 0) == 4 || ReadMemoryInt(GE.camera, 0) == 9))
		{
			for(int i = 0; i < 64; i++)
			{
				pointerdump[i] = BONDDATA;
				Sleep(1);
			}
			SortArray(pointerdump, sizeof pointerdump / sizeof pointerdump[0]);
			playerbase = pointerdump[0];
#ifdef PLAYER2MODE
			for(int j = 1; j < 64; j++)
				if(pointerdump[j - 1] != pointerdump[j]) // search pointerdump array until P2's pointer is found
				{
					playerbase = pointerdump[j];
					break;
				}
#endif
		}
	}
	else if(currentgame == PLAYINGPERFECTDARK)
	{
		if(playerbase != JOANNADATA && (ReadMemoryInt(PD.camera, 0) == 1 && ReadMemoryFloat(JOANNADATA, PD.camx) == 0 && ReadMemoryFloat(JOANNADATA, PD.camy) == -4 && !ReadMemoryInt(PD.menu, 0) && !ReadMemoryInt(PD.pause, 0) || ReadMemoryInt(PD.camera, 0) == 4 || ReadMemoryInt(PD.camera, 0) == 6))
		{
			for(int i = 0; i < 64; i++)
			{
				pointerdump[i] = JOANNADATA;
				Sleep(1);
			}
			SortArray(pointerdump, sizeof pointerdump / sizeof pointerdump[0]);
			playerbase = pointerdump[0];
		}
		if(ReadMemoryInt(playerbase, PD.grabflag) == 3 && bikebase[1] != 3) // player has hopped on a bike, search for bike pointer
		{
			const int bikepointers[14] = {0x8052D5DC, 0x8054B1E8, 0x80552D8C, 0x8052A4FC, 0x8054ECDC, 0x80556DF4, 0x80501438, 0x8050EED4, 0x805142A4, 0x804CA4D4, 0x804D10D4, 0x803FF4F0, 0x803FF6A4, 0x803FF7BC};
			int bikedump[64][14];
			for(int i = 0; i < 64; i++)
			{
				for(int j = 0; j < 14; j++)
				{
					bikedump[i][j] = ReadMemoryInt(bikepointers[j] - 0x80000000, 0);
					if(j > 1 && bikedump[i][j] > 0x80000000 && bikedump[i][j] < 0x80800000 && ReadMemoryFloat(bikedump[i][j] - 0x80000000 + 0x6C, 0) <= BIKEXROTATIONLIMIT && ReadMemoryFloat(bikedump[i][j] - 0x80000000 + 0x6C, 0) >= -BIKEXROTATIONLIMIT && ReadMemoryFloat(bikedump[i][j] - 0x80000000 + 0x6C, PD.bikeroll) <= BIKEROLLLIMIT && ReadMemoryFloat(bikedump[i][j] - 0x80000000 + 0x6C, PD.bikeroll) >= -BIKEROLLLIMIT && (bikedump[i][j] == bikedump[i][j - 1] || bikedump[i][j] == bikedump[i][j - 2] || bikedump[i][j - 1] == bikedump[i][j - 2]))
					{
						bikebase[0] = bikedump[i][j] - 0x80000000 + 0x6C;
						break;
					}
				}
				if(bikebase[0])
					break;
				else
					Sleep(1);
			}
		}
		else if(bikebase[1] != 3)
			bikebase[0] = 0;
		bikebase[1] = ReadMemoryInt(playerbase, PD.grabflag); // remember player's last grab state (used to find the exact moment when the player hops on a bike)
	}
}
//==========================================================================
// Purpose: returns a value, which is then used to check what game is running
// Q: What is happening here?
// A: This function looks up some static addresses and if the values are within the expected ranges the program can assume that the game is currently running
//==========================================================================
int Game()
{
	const int ge_camera = ReadMemoryInt(GE.camera, 0), ge_page = ReadMemoryInt(GE.menupage, 0), ge_pause = ReadMemoryInt(GE.pause, 0), ge_exit = ReadMemoryInt(GE.exit, 0), pd_menu = ReadMemoryInt(PD.menu, 0), pd_camera = ReadMemoryInt(PD.camera, 0), pd_pause = ReadMemoryInt(PD.pause, 0), pd_romcheck = ReadMemoryInt(PD.menuitem, 0);
	const float ge_crosshairx = ReadMemoryFloat(GE.menux, 0), ge_crosshairy = ReadMemoryFloat(GE.menuy, 0);
	if(ge_camera >= 0 && ge_camera <= 10 && ge_page >= -1 && ge_page <= 25 && ge_pause >= 0 && ge_pause <= 1 && ge_exit >= 0 && ge_exit <= 1 && ge_crosshairx >= 20 && ge_crosshairx <= 420 && ge_crosshairy >= 20 && ge_crosshairy <= 310) // if GoldenEye 007 is current game
		return PLAYINGGOLDENEYE;
	if(pd_menu >= 0 && pd_menu <= 1 && pd_camera >= 0 && pd_camera <= 7 && pd_pause >= 0 && pd_pause <= 1 && pd_romcheck == 0x04010000) // if Perfect Dark is current game
		return PLAYINGPERFECTDARK;
	return PLAYINGUNKNOWN; // if GE/PD not detected, return unknown rom
}
//==========================================================================
// Purpose: returns 1 if emulator is detected, and set emulator memory locations
// Changes Globals: emuhandle, emuoffset, fastemu, tickrate
//==========================================================================
int EmulatorDetected()
{
	emuhandle = NULL;
	HANDLE processes; // will store a snapshot of all processes
	PROCESSENTRY32 pe32; // stores basic info of a process, using this one to read the ProcessID from
	processes = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); // make process snapshot
	pe32.dwSize = sizeof(PROCESSENTRY32); // correct size
	Process32First(processes, &pe32); // read info about the first process into pe32
	do // loop to find emulator
	{
		if(strcmp(pe32.szExeFile, "1964.exe") == 0 || strcmp(pe32.szExeFile, "1964_6X.exe") == 0 || strcmp(pe32.szExeFile, "1964_9X.exe") == 0 || strcmp(pe32.szExeFile, "1964_ultrafast.exe") == 0) // if 1964 0.8.5/1964 1.1 Ultrafast was found
		{
			emuhandle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			emuoffset = 0x20000000; // emulator offset is used for injecting into the ROM memory area in the emu
			fastemu = 1; // this is used as a flag to show the overclocked emu only options
			tickrate = 2; // a high injection rate is needed to properly use the GE aiming system and PD 60fps hack
			break;
		}
		if(strcmp(pe32.szExeFile, "1964_Slow.exe") == 0) // if 1964 0.8.5 was found
		{
			emuhandle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			emuoffset = 0x20000000; // emulator offset is used for injecting into the ROM memory area in the emu
			fastemu = 0;
			tickrate = 4;
			break;
		}
		if(strcmp(pe32.szExeFile, "mupen64pp.exe") == 0) // if mupen64++ beta 0.1.3.12 was found
		{
			emuhandle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			emuoffset = 0x008DFC60;
			fastemu = 0;
			tickrate = 4;
			break;
		}
		if(strcmp(pe32.szExeFile, "mupen64plus-ui-console.exe") == 0) // if mupen64+ 1.99.5 was found
		{
			emuhandle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			emuoffset = 0x101FC6D0;
			fastemu = 0;
			tickrate = 4;
			break;
		}
		if(strcmp(pe32.szExeFile, "Project64.exe") == 0) // if Project64 1.6 was found
		{
			int versioncheck;
			emuhandle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			ReadProcessMemory(emuhandle, (LPVOID)0x0046AB90, &versioncheck, sizeof(versioncheck), NULL);
			if(versioncheck == 1785688656) // if version is PJ64 1.6
				ReadProcessMemory(emuhandle, (LPVOID)0x004D6A3C, &emuoffset, sizeof(emuoffset), NULL); // look up rom memory offset in PJ64 1.6
			else // unsupported PJ64 version, emulator not found
				emuhandle = NULL;
			fastemu = 0;
			tickrate = 4;
			break;
		}
	}
	while(Process32Next(processes, &pe32)); // loop continued until Process32Next deliver NULL or its interrupted with the "break" above
	CloseHandle(processes);
	return emuhandle ? 1 : 0;
}
//==========================================================================
// Purpose: displays important debugging information to programmer
//==========================================================================
void DebugInterface()
{
#ifdef DEBUGMODE
	int safetoinject = 0;
	printf("\n Debugging Information (Press 9 to disable)\n%s\n\n   ", LINE);
	if(currentgame)
		printf("Game: %s\n\n\n Memory Information (Tickrate: %dHz)\n%s\n\n   ", currentgame == PLAYINGGOLDENEYE ? (ReadMemoryInt(GE.customweaponflag, 0) == 0x756E6172 ? "GoldenEye 007" : "GoldenEye 007 (Custom Weapons)") : "Perfect Dark", 1000 / tickrate, LINE);
	if(currentgame == PLAYINGGOLDENEYE)
	{
		const int menupage = ReadMemoryInt(GE.menupage, 0);
		if(menupage != 11 && menupage != 23)
			printf("Menu Page ID: %d\t\t\t Address: 0x%p\n", menupage, GE.menupage + emuoffset);
		else if(playerbase)
		{
			const int camera = ReadMemoryInt(GE.camera, 0), death = ReadMemoryInt(playerbase, GE.deathflag), watch = ReadMemoryInt(playerbase, GE.watch), exit = ReadMemoryInt(GE.exit, 0), pause = ReadMemoryInt(GE.pause, 0), aimingflag = ReadMemoryInt(playerbase, GE.aimingflag), tankflag = ReadMemoryInt(GE.tankflag, 0), mproundend = ReadMemoryInt(GE.matchended, 0), mppausemenu = ReadMemoryInt(playerbase, GE.multipausemenu);
			const float camx = ReadMemoryFloat(playerbase, GE.camx), camy = ReadMemoryFloat(playerbase, GE.camy), crosshairx = ReadMemoryFloat(playerbase, GE.crosshairx), crosshairy = ReadMemoryFloat(playerbase, GE.crosshairy), fov = ReadMemoryFloat(playerbase, GE.fov), tankx = ReadMemoryFloat(GE.tankxrot, 0);
			if(camx >= 0 && camx <= 360 && camy >= -90 && camy <= 90 && fov >= 7 && fov <= 60 && death == 0 && watch == 0 && pause == 0 && (camera == 4 || camera == 0) && exit == 1 && menupage == 11 && !mproundend && !mppausemenu)
				safetoinject = 1;
			printf("Safe to inject: %d\n   Menu Page ID: %d\t\t\t Address: 0x%p\n   Camera: %d\t\t\t\t Address: 0x%p\n   Death: %d\t\t\t\t Address: 0x%p\n   Camera X: %1.4f\t\t\t Address: 0x%p\n   Camera Y: %1.4f\t\t\t Address: 0x%p\n   Crosshair X: %1.4f\t\t\t Address: 0x%p\n   Crosshair Y: %1.4f\t\t\t Address: 0x%p\n   Fov: %1.4f\t\t\t\t Address: 0x%p\n   Watch: %d\t\t\t\t Address: 0x%p\n   Exit: %d\t\t\t\t Address: 0x%p\n   Pause: %d\t\t\t\t Address: 0x%p\n   Aiming flag: %d\t\t\t Address: 0x%p\n   Tank flag: %d\t\t\t\t Address: 0x%p\n", safetoinject, menupage, GE.menupage + emuoffset, camera, GE.camera + emuoffset, death, playerbase + GE.deathflag + emuoffset, camx, playerbase + GE.camx + emuoffset, camy, playerbase + GE.camy + emuoffset, crosshairx, playerbase + GE.crosshairx + emuoffset, crosshairy, playerbase + GE.crosshairy + emuoffset, fov, playerbase + GE.fov + emuoffset, watch, playerbase + GE.watch + emuoffset, exit, GE.exit + emuoffset, pause, GE.pause + emuoffset, aimingflag, playerbase + GE.aimingflag + emuoffset, tankflag, GE.tankflag + emuoffset);
			if(tankflag)
				printf("   Tank X: %1.4f\t\t\t Address: 0x%p", tankx, GE.tankxrot + emuoffset);
		}
	}
	else if(currentgame == PLAYINGPERFECTDARK)
	{
		const int camera = ReadMemoryInt(PD.camera, 0), death = ReadMemoryInt(playerbase, PD.deathflag), menu = ReadMemoryInt(PD.menu, 0), pause = ReadMemoryInt(PD.pause, 0), aimingflag = ReadMemoryInt(playerbase, PD.aimingflag), grabflag = ReadMemoryInt(playerbase, PD.grabflag);
		const float camx = ReadMemoryFloat(playerbase, PD.camx), camy = ReadMemoryFloat(playerbase, PD.camy), fov = ReadMemoryFloat(playerbase, PD.fov), bikex = ReadMemoryFloat(bikebase[0], 0), bikeroll = ReadMemoryFloat(bikebase[0], PD.bikeroll);
		if(camx >= 0 && camx <= 360 && camy >= -90 && camy <= 90 && fov >= 2 && fov <= 60 && death == 0 && menu == 1 && pause == 0 && camera == 1 && (grabflag == 0 || grabflag == 4 || grabflag == 3 && bikebase[0] && bikex <= BIKEXROTATIONLIMIT && bikex >= -BIKEXROTATIONLIMIT && bikeroll <= BIKEROLLLIMIT && bikeroll >= -BIKEROLLLIMIT))
			safetoinject = 1;
		if(playerbase)
		{
			printf("Safe to inject: %d\n   FPS: %s\t\t\t %s\n   Camera: %d\t\t\t\t Address: 0x%p\n   Death: %d\t\t\t\t Address: 0x%p\n   Camera X: %1.4f\t\t\t Address: 0x%p\n   Camera Y: %1.4f\t\t\t Address: 0x%p\n   Fov: %1.4f\t\t\t\t Address: 0x%p\n   Menu: %d\t\t\t\t Address: 0x%p\n   Pause: %d\t\t\t\t Address: 0x%p\n   Aiming Flag: %d\t\t\t Address: 0x%p\n   Grab: %d\t\t\t\t Address: 0x%p\n", safetoinject, ReadMemoryInt(0x0008D934, 0) != 0x8005EE68 ? "Unlocked" : "Locked at 30", fastemu && ReadMemoryInt(0x0008D934, 0) == 0x8005EE68 ? "Forcing 60fps mode..." : "", camera, PD.camera + emuoffset, death, playerbase + PD.deathflag + emuoffset, camx, playerbase + PD.camx + emuoffset, camy, playerbase + PD.camy + emuoffset, fov, playerbase + PD.fov + emuoffset, menu, PD.menu + emuoffset, pause, PD.pause + emuoffset, aimingflag, playerbase + PD.aimingflag + emuoffset, grabflag, playerbase + PD.grabflag + emuoffset);
			if(grabflag == 3 && safetoinject)
				printf("   Bike X: %1.4f\t\t\t Address: 0x%p\n   Bike Roll: %1.4f\t\t\t Address: 0x%p", bikex, bikebase[0] + emuoffset, bikeroll, bikebase[0] + PD.bikeroll + emuoffset);
		}
	}
	else
		printf("Waiting for correct ROM...\n");
#endif
}
//==========================================================================
// Purpose: read interger from memory and then return memory value
// Parameter: address location plus offset (offset is ignored when set to 0)
//==========================================================================
int ReadMemoryInt(const int addr, const int offset)
{
	int output;
	ReadProcessMemory(emuhandle, (LPVOID)(addr + emuoffset + offset), &output, sizeof(output), NULL);
	return output;
}
//==========================================================================
// Purpose: read float from memory and then return memory value
// Parameter: address location plus offset (offset is ignored when set to 0)
//==========================================================================
float ReadMemoryFloat(const int addr, const int offset)
{
	float output;
	ReadProcessMemory(emuhandle, (LPVOID)(addr + emuoffset + offset), &output, sizeof(output), NULL);
	return output;
}
//==========================================================================
// Purpose: write int to memory location
// Parameter: address location, value and offset (offset is ignored when set to 0)
//==========================================================================
void WriteMemoryInt(const int addr, const int value, const int offset)
{
	WriteProcessMemory(emuhandle, (LPVOID)(addr + emuoffset + offset), &value, sizeof(value), NULL);
}
//==========================================================================
// Purpose: write float to memory location
// Parameter: address location, value and offset (offset is ignored when set to 0)
//==========================================================================
void WriteMemoryFloat(const int addr, const float value, const int offset)
{
	WriteProcessMemory(emuhandle, (LPVOID)(addr + emuoffset + offset), &value, sizeof(value), NULL);
}
//==========================================================================
// Purpose: clear screen without using system("cls")
//==========================================================================
void ClearScreen()
{
	DWORD n; // number of characters written
	DWORD size; // number of visible characters
	COORD coord = {0}; // top left screen position
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	HANDLE h = GetStdHandle(STD_OUTPUT_HANDLE); // get a handle to the console
	GetConsoleScreenBufferInfo(h, &csbi);
	size = csbi.dwSize.X * csbi.dwSize.Y; // find the number of characters to overwrite
	FillConsoleOutputCharacter(h, TEXT(' '), size, coord, &n); // overwrite the screen buffer with whitespace
	GetConsoleScreenBufferInfo(h, &csbi);
	FillConsoleOutputAttribute(h, csbi.wAttributes, size, coord, &n);
	SetConsoleCursorPosition(h, coord); // reset the cursor to the top left position
}
//==========================================================================
// Purpose: get mouse x and y and update global vars xrot/yrot with current mouse input values
// Changes Globals: xrot, yrot, lastx, lasty
//==========================================================================
void MouseMovement()
{
	POINT mouse; // y and x for mouse
	GetCursorPos(&mouse); // get x and y of mouse
	SetCursorPos(mouselock.x, mouselock.y); // set mouse position back to the lock position
	xrot += mouse.x - mouselock.x - lastx; // set the xrot to xrot with the addition of the difference in the x position
	yrot += mouse.y - mouselock.y - lasty; // set the yrot to yrot with the addition of the difference in the y position
	lastx = mouse.x - mouselock.x; // set lastx to the current x position
	lasty = mouse.y - mouselock.y; // set lasty to the current y position
}
//==========================================================================
// Purpose: init timer (needed for TimeUpdate() which is used for GEAimMode)
//==========================================================================
void TimerInit()
{
	LARGE_INTEGER freqtemp; // get timer freq
	QueryPerformanceFrequency(&freqtemp);
	TIME.freq = freqtemp.LowPart;
}
//==========================================================================
// Purpose: calculate delta time for GE aim crosshair scroll
//==========================================================================
void TimeUpdate()
{
	LARGE_INTEGER temptime;
	TIME.last = TIME.current; // set last, current and diff timers
	QueryPerformanceCounter(&temptime);
	TIME.current = temptime.LowPart;
	TIME.diff = TIME.current - TIME.last;
	TIME.factor = (float)(TIME.diff) / ((float)TIME.freq / 72.0f); // set time factor
	TIME.step = TIME.factor / 72.0f; // set time step
}
//==========================================================================
// Purpose: sorting function for pointer scanning
//==========================================================================
void SortArray(int *a, const int n)
{
	if(n < 2)
		return;
	int p = a[n / 2];
	int *l = a;
	int *r = a + n - 1;
	while(l <= r)
	{
		while(*l < p)
			l++;
		while(*r > p)
			r--;
		if(l <= r)
		{
			int t = *l;
			*l++ = *r;
			*r-- = t;
		}
	}
	SortArray(a, r - a + 1);
	SortArray(l, a + n - l);
}