//==========================================================================
// Mouse Injector for GoldenEye 007/Perfect Dark
//==========================================================================
// Copyright (c) 2014, stolen + carnivorous's fixes
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the <organization> nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL STOLEN BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//==========================================================================
// input for interface
#define K_CTRL (GetAsyncKeyState(0xA2) || GetAsyncKeyState(0xA3)) // control
#define K_4 GetAsyncKeyState(0x34) // key '4'
#define K_5 GetAsyncKeyState(0x35) // key '5'
#define K_6 GetAsyncKeyState(0x36) // key '6'
#define K_7 GetAsyncKeyState(0x37) // key '7'
#define K_8 GetAsyncKeyState(0x38) // key '8'
#define K_9 GetAsyncKeyState(0x39) // key '9'
#define K_0 GetAsyncKeyState(0x30) // key '0'
#define K_PLUS (GetAsyncKeyState(0x6B) || GetAsyncKeyState(0xBB)) // key '+'
#define K_MINUS (GetAsyncKeyState(0x6D) || GetAsyncKeyState(0xBD)) // key '-'
#define K_F9 GetAsyncKeyState(0x78) // key 'F9'
// misc
#define TITLE "GoldenEye 007/Perfect Dark Mouse Injector\n"
#define LINE "_______________________________________________________________"
#define EDITINGSENSITIVITY 0
#define EDITINGCROSSHAIR 1
#define PLAYINGUNKNOWN 0
#define PLAYINGGOLDENEYE 1
#define PLAYINGPERFECTDARK 2
#define GEGUNAIMLIMIT 6.879164696
#define GECROSSHAIRLIMIT 5.159373283
#define PDGUNAIMLIMIT 14.12940025
#define PDCROSSHAIRLIMIT 18.76135635
#define TANKXROTATIONLIMIT 6.283093
#define BIKEXROTATIONLIMIT 6.282185078
#define BIKEROLLLIMIT 0.7852724195
#define BONDDATA ReadMemoryInt(ReadMemoryInt(0x8007A0B0 - 0x80000000, 0), 0) - 0x80000000 + 0x9C
#define JOANNADATA ReadMemoryInt(ReadMemoryInt(0x8009A024 - 0x80000000, 0), 0) - 0x80000000 + 0xAC
// build flags
// #define DEBUGMODE // uncomment for debug mode
// #define PLAYER2MODE // uncomment for P2 detection in GE (used for GE-MP build)
#ifndef DEBUGMODE // remove the input define for debug mode (9)
	#undef K_9
	#define K_9 0
#endif

struct
{
	int deathflag, camx, camy, fov, crosshairx, crosshairy, watch, crouchheight, gunx, guny, aimingflag, currentweapon, multipausemenu; // these offset addresses require playerbase to work
	int camera, exit, pause, menupage, menux, menuy, tankxrot, tankflag, controller, matchended, customweaponflag; // misc vars to store static addresses
} GE = {
	// GOLDENEYE ADDRESSES - OFFSET ADDRESSES BELOW (REQUIRES PLAYERBASE TO USE)
	.deathflag = 0x000D3038 - 0x000D2FFC,
	.camx = 0x000D30A8 - 0x000D2FFC,
	.camy = 0x000D30B8 - 0x000D2FFC,
	.fov = 0x000D4124 - 0x000D2FFC,
	.crosshairx = 0x000D3F50 - 0x000D2FFC,
	.crosshairy = 0x000D3F54 - 0x000D2FFC,
	.watch = 0x000D3128 - 0x000D2FFC,
	.crouchheight = 0x000D3000 - 0x000D2FFC,
	.gunx = 0x000D3F64 - 0x000D2FFC,
	.guny = 0x000D3F68 - 0x000D2FFC,
	.aimingflag = 0x000D3084 - 0x000D2FFC,
	.currentweapon = 0x000D37D0 - 0x000D2FFC,
	.multipausemenu = 0x000A9D24 - 0x000A73FC,
	// STATIC ADDRESSES BELOW
	.camera = 0x00036494, // camera flag (0 = multiplayer, 1 = map overview, 2 = start flyby, 3 = in flyby, 4 = player in control, 5 = trigger restart map)
	.exit = 0x000364B0, // exit flag (0 = disable controls, 1 = enable controls)
	.pause = 0x00048370, // pause flag (1 = GE is paused)
	.menupage = 0x0002A8C0, // menu page id
	.menux = 0x0002A908, // crosshair menu cursor x axis
	.menuy = 0x0002A90C, // crosshair menu cursor y axis
	.tankxrot = 0x00036484, // tank x rotation
	.tankflag = 0x00036448, // tank flag (0 = walking, 1 = in-tank)
#ifndef PLAYER2MODE
	.controller = 0x00067CA4, // player 1 controller address
#else
	.controller = 0x00067CAC, // player 2 controller address
#endif
	.matchended = 0x0008C700, // multiplayer match flag
	.customweaponflag = 0x002ACDD8, // location of the first weapon title (used to detect if user is playing a GE rom hack with custom weapons)
};

struct
{
	int deathflag, camx, camy, fov, crosshairx, crosshairy, grabflag, gunrx, gunry, gunlx, gunly, aimingflag, bikeroll; // these offset addresses require playerbase base to work
	int menu, camera, pause, menuitem, fpscounter, timer; // misc vars to store static addresses
} PD = {
	// PERFECT DARK ADDRESSES - OFFSET ADDRESSES BELOW (REQUIRES PLAYERBASE/BIKEBASE TO USE)
	.deathflag = 0x001BB778 - 0x001BB74C,
	.camx = 0x001BB7E4 - 0x001BB74C,
	.camy = 0x001BB7F4 - 0x001BB74C,
	.fov = 0x001BCEE8 - 0x001BB74C,
	.crosshairx = 0x001BCD08 - 0x001BB74C,
	.crosshairy = 0x001BCD0C - 0x001BB74C,
	.grabflag = 0x001BB850 - 0x001BB74C,
	.gunrx = 0x001BC374 - 0x001BB74C,
	.gunry = 0x001BC378 - 0x001BB74C,
	.gunlx = 0x001BCB18 - 0x001BB74C,
	.gunly = 0x001BCB1C - 0x001BB74C,
	.aimingflag = 0x001BB7C0 - 0x001BB74C,
	.bikeroll = 0x0052D69C - 0x0052D64C,
	// STATIC ADDRESSES BELOW
	.menu = 0x00070750, // menu flag (0 = PD is in menu)
	.camera = 0x0009A26C, // camera flag (1 = gameplay, 2 & 3 = ???, 4 = multiplayer sweep, 5 = gameover screen, 6 = cutscene mode)
	.pause = 0x00084014, // menu flag (1 = PD is paused)
	.menuitem = 0x000739F8, // menu item flag (used to check if PD is running)
	.fpscounter = 0x0008D934, // fps counter (used to detect when PD is running at locked speed)
	.timer = 0x0008DBD0, // we intentionally screw with this timer address to force PD to run at unlocked speed
};

struct
{
	int mousetoggle, sensitivity, crosshair, invertpitch, geaimmode, debug, showsettings, selectedoption, crouchkey;
} CFG = {
	.mousetoggle = 0, .sensitivity = 20, .crosshair = 3, .invertpitch = 0, .geaimmode = 1, .debug = 0, .showsettings = 0, .selectedoption = 0, .crouchkey = 0xA2,
};

struct
{
	unsigned long long int last, current, diff, freq;
	float factor, step;
} TIME;

POINT mouselock; // x and y var for mouse lock
HANDLE emuhandle; // this stores the emulator process id
int emuoffset; // var used for adding emulator offsets to memory address injections (see RWMemory functions)
int xrot = 0, yrot = 0, lastx = 0, lasty = 0; // global vars required for the MouseMovement function
float crosshairposx, crosshairposy, aimx, aimy; // global vars required for aiming mode function
int playerbase = 0; // stores current player's bonddata/joannadata address
int bikebase[2]; // stores hoverbike's address and player's last grab state (used to find the exact moment when the player hops on a bike)
int currentgame = PLAYINGUNKNOWN;
int fastemu = 0; // var used to determine if the emu is able to use the PD 60fps hack and GE aiming system (both require a high frame rate to work)
int tickrate = 4; // limit the main loop to 250Hz (500Hz is used for oc emulators)

void Input();
void Interface();
void LoadSettings();
void SaveSettings();
void Inject();
void Crouch();
int GEAimMode(const int aimingflag, const float fov);
void PDSpeedHack();
void DetectMap();
int Game();
int EmulatorDetected();
void DebugInterface();
int ReadMemoryInt(const int addr, const int offset);
float ReadMemoryFloat(const int addr, const int offset);
void WriteMemoryInt(const int addr, const int value, const int offset);
void WriteMemoryFloat(const int addr, const float value, const int offset);
void ClearScreen();
void MouseMovement();
void TimerInit();
void TimeUpdate();
void SortArray(int *a, const int n);